import "./form-datepicker.css";
import { defineComponent as $e, resolveComponent as he, openBlock as f, createBlock as L, Teleport as De, createElementBlock as V, normalizeClass as J, normalizeStyle as Me, Fragment as B, renderList as K, withModifiers as M, toDisplayString as I, createCommentVNode as N, createElementVNode as k, resolveDynamicComponent as W, withCtx as pe, createTextVNode as be, mergeProps as ue, createVNode as ye, createSlots as Te } from "vue";
import { c as de, a as fe } from "../../_commonjsHelpers-aeeeeb92.js";
import Oe from "../form-input/form-input.js";
import Ye from "../button/button.js";
import { g as ve, h as Ce, j as Le, k as qe, a as He, f as Ie, b as Ne, l as Ae, x as We } from "../../icons-fca12ed8.js";
import { r as ge } from "../../helper-4d4ed314.js";
import { _ as Se } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
var Ve = { exports: {} };
(function(e, t) {
  (function(n, i) {
    e.exports = i();
  })(de, function() {
    var n = 1e3, i = 6e4, l = 36e5, $ = "millisecond", D = "second", a = "minute", m = "hour", g = "day", Z = "week", h = "month", C = "quarter", q = "year", F = "date", Q = "Invalid Date", U = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, ie = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, ae = { name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"), ordinal: function(p) {
      var o = ["th", "st", "nd", "rd"], r = p % 100;
      return "[" + p + (o[(r - 20) % 10] || o[r] || o[0]) + "]";
    } }, E = function(p, o, r) {
      var u = String(p);
      return !u || u.length >= o ? p : "" + Array(o + 1 - u.length).join(r) + p;
    }, oe = { s: E, z: function(p) {
      var o = -p.utcOffset(), r = Math.abs(o), u = Math.floor(r / 60), s = r % 60;
      return (o <= 0 ? "+" : "-") + E(u, 2, "0") + ":" + E(s, 2, "0");
    }, m: function p(o, r) {
      if (o.date() < r.date())
        return -p(r, o);
      var u = 12 * (r.year() - o.year()) + (r.month() - o.month()), s = o.clone().add(u, h), c = r - s < 0, d = o.clone().add(u + (c ? -1 : 1), h);
      return +(-(u + (r - s) / (c ? s - d : d - s)) || 0);
    }, a: function(p) {
      return p < 0 ? Math.ceil(p) || 0 : Math.floor(p);
    }, p: function(p) {
      return { M: h, y: q, w: Z, d: g, D: F, h: m, m: a, s: D, ms: $, Q: C }[p] || String(p || "").toLowerCase().replace(/s$/, "");
    }, u: function(p) {
      return p === void 0;
    } }, R = "en", P = {};
    P[R] = ae;
    var le = function(p) {
      return p instanceof te;
    }, ee = function p(o, r, u) {
      var s;
      if (!o)
        return R;
      if (typeof o == "string") {
        var c = o.toLowerCase();
        P[c] && (s = c), r && (P[c] = r, s = c);
        var d = o.split("-");
        if (!s && d.length > 1)
          return p(d[0]);
      } else {
        var S = o.name;
        P[S] = o, s = S;
      }
      return !u && s && (R = s), s || !u && R;
    }, b = function(p, o) {
      if (le(p))
        return p.clone();
      var r = typeof o == "object" ? o : {};
      return r.date = p, r.args = arguments, new te(r);
    }, v = oe;
    v.l = ee, v.i = le, v.w = function(p, o) {
      return b(p, { locale: o.$L, utc: o.$u, x: o.$x, $offset: o.$offset });
    };
    var te = function() {
      function p(r) {
        this.$L = ee(r.locale, null, !0), this.parse(r);
      }
      var o = p.prototype;
      return o.parse = function(r) {
        this.$d = function(u) {
          var s = u.date, c = u.utc;
          if (s === null)
            return /* @__PURE__ */ new Date(NaN);
          if (v.u(s))
            return /* @__PURE__ */ new Date();
          if (s instanceof Date)
            return new Date(s);
          if (typeof s == "string" && !/Z$/i.test(s)) {
            var d = s.match(U);
            if (d) {
              var S = d[2] - 1 || 0, w = (d[7] || "0").substring(0, 3);
              return c ? new Date(Date.UTC(d[1], S, d[3] || 1, d[4] || 0, d[5] || 0, d[6] || 0, w)) : new Date(d[1], S, d[3] || 1, d[4] || 0, d[5] || 0, d[6] || 0, w);
            }
          }
          return new Date(s);
        }(r), this.$x = r.x || {}, this.init();
      }, o.init = function() {
        var r = this.$d;
        this.$y = r.getFullYear(), this.$M = r.getMonth(), this.$D = r.getDate(), this.$W = r.getDay(), this.$H = r.getHours(), this.$m = r.getMinutes(), this.$s = r.getSeconds(), this.$ms = r.getMilliseconds();
      }, o.$utils = function() {
        return v;
      }, o.isValid = function() {
        return this.$d.toString() !== Q;
      }, o.isSame = function(r, u) {
        var s = b(r);
        return this.startOf(u) <= s && s <= this.endOf(u);
      }, o.isAfter = function(r, u) {
        return b(r) < this.startOf(u);
      }, o.isBefore = function(r, u) {
        return this.endOf(u) < b(r);
      }, o.$g = function(r, u, s) {
        return v.u(r) ? this[u] : this.set(s, r);
      }, o.unix = function() {
        return Math.floor(this.valueOf() / 1e3);
      }, o.valueOf = function() {
        return this.$d.getTime();
      }, o.startOf = function(r, u) {
        var s = this, c = !!v.u(u) || u, d = v.p(r), S = function(z, Y) {
          var j = v.w(s.$u ? Date.UTC(s.$y, Y, z) : new Date(s.$y, Y, z), s);
          return c ? j : j.endOf(g);
        }, w = function(z, Y) {
          return v.w(s.toDate()[z].apply(s.toDate("s"), (c ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(Y)), s);
        }, T = this.$W, O = this.$M, H = this.$D, X = "set" + (this.$u ? "UTC" : "");
        switch (d) {
          case q:
            return c ? S(1, 0) : S(31, 11);
          case h:
            return c ? S(1, O) : S(0, O + 1);
          case Z:
            var G = this.$locale().weekStart || 0, _ = (T < G ? T + 7 : T) - G;
            return S(c ? H - _ : H + (6 - _), O);
          case g:
          case F:
            return w(X + "Hours", 0);
          case m:
            return w(X + "Minutes", 1);
          case a:
            return w(X + "Seconds", 2);
          case D:
            return w(X + "Milliseconds", 3);
          default:
            return this.clone();
        }
      }, o.endOf = function(r) {
        return this.startOf(r, !1);
      }, o.$set = function(r, u) {
        var s, c = v.p(r), d = "set" + (this.$u ? "UTC" : ""), S = (s = {}, s[g] = d + "Date", s[F] = d + "Date", s[h] = d + "Month", s[q] = d + "FullYear", s[m] = d + "Hours", s[a] = d + "Minutes", s[D] = d + "Seconds", s[$] = d + "Milliseconds", s)[c], w = c === g ? this.$D + (u - this.$W) : u;
        if (c === h || c === q) {
          var T = this.clone().set(F, 1);
          T.$d[S](w), T.init(), this.$d = T.set(F, Math.min(this.$D, T.daysInMonth())).$d;
        } else
          S && this.$d[S](w);
        return this.init(), this;
      }, o.set = function(r, u) {
        return this.clone().$set(r, u);
      }, o.get = function(r) {
        return this[v.p(r)]();
      }, o.add = function(r, u) {
        var s, c = this;
        r = Number(r);
        var d = v.p(u), S = function(O) {
          var H = b(c);
          return v.w(H.date(H.date() + Math.round(O * r)), c);
        };
        if (d === h)
          return this.set(h, this.$M + r);
        if (d === q)
          return this.set(q, this.$y + r);
        if (d === g)
          return S(1);
        if (d === Z)
          return S(7);
        var w = (s = {}, s[a] = i, s[m] = l, s[D] = n, s)[d] || 1, T = this.$d.getTime() + r * w;
        return v.w(T, this);
      }, o.subtract = function(r, u) {
        return this.add(-1 * r, u);
      }, o.format = function(r) {
        var u = this, s = this.$locale();
        if (!this.isValid())
          return s.invalidDate || Q;
        var c = r || "YYYY-MM-DDTHH:mm:ssZ", d = v.z(this), S = this.$H, w = this.$m, T = this.$M, O = s.weekdays, H = s.months, X = s.meridiem, G = function(Y, j, x, ne) {
          return Y && (Y[j] || Y(u, c)) || x[j].slice(0, ne);
        }, _ = function(Y) {
          return v.s(S % 12 || 12, Y, "0");
        }, z = X || function(Y, j, x) {
          var ne = Y < 12 ? "AM" : "PM";
          return x ? ne.toLowerCase() : ne;
        };
        return c.replace(ie, function(Y, j) {
          return j || function(x) {
            switch (x) {
              case "YY":
                return String(u.$y).slice(-2);
              case "YYYY":
                return v.s(u.$y, 4, "0");
              case "M":
                return T + 1;
              case "MM":
                return v.s(T + 1, 2, "0");
              case "MMM":
                return G(s.monthsShort, T, H, 3);
              case "MMMM":
                return G(H, T);
              case "D":
                return u.$D;
              case "DD":
                return v.s(u.$D, 2, "0");
              case "d":
                return String(u.$W);
              case "dd":
                return G(s.weekdaysMin, u.$W, O, 2);
              case "ddd":
                return G(s.weekdaysShort, u.$W, O, 3);
              case "dddd":
                return O[u.$W];
              case "H":
                return String(S);
              case "HH":
                return v.s(S, 2, "0");
              case "h":
                return _(1);
              case "hh":
                return _(2);
              case "a":
                return z(S, w, !0);
              case "A":
                return z(S, w, !1);
              case "m":
                return String(w);
              case "mm":
                return v.s(w, 2, "0");
              case "s":
                return String(u.$s);
              case "ss":
                return v.s(u.$s, 2, "0");
              case "SSS":
                return v.s(u.$ms, 3, "0");
              case "Z":
                return d;
            }
            return null;
          }(Y) || d.replace(":", "");
        });
      }, o.utcOffset = function() {
        return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
      }, o.diff = function(r, u, s) {
        var c, d = this, S = v.p(u), w = b(r), T = (w.utcOffset() - this.utcOffset()) * i, O = this - w, H = function() {
          return v.m(d, w);
        };
        switch (S) {
          case q:
            c = H() / 12;
            break;
          case h:
            c = H();
            break;
          case C:
            c = H() / 3;
            break;
          case Z:
            c = (O - T) / 6048e5;
            break;
          case g:
            c = (O - T) / 864e5;
            break;
          case m:
            c = O / l;
            break;
          case a:
            c = O / i;
            break;
          case D:
            c = O / n;
            break;
          default:
            c = O;
        }
        return s ? c : v.a(c);
      }, o.daysInMonth = function() {
        return this.endOf(h).$D;
      }, o.$locale = function() {
        return P[this.$L];
      }, o.locale = function(r, u) {
        if (!r)
          return this.$L;
        var s = this.clone(), c = ee(r, u, !0);
        return c && (s.$L = c), s;
      }, o.clone = function() {
        return v.w(this.$d, this);
      }, o.toDate = function() {
        return new Date(this.valueOf());
      }, o.toJSON = function() {
        return this.isValid() ? this.toISOString() : null;
      }, o.toISOString = function() {
        return this.$d.toISOString();
      }, o.toString = function() {
        return this.$d.toUTCString();
      }, p;
    }(), me = te.prototype;
    return b.prototype = me, [["$ms", $], ["$s", D], ["$m", a], ["$H", m], ["$W", g], ["$M", h], ["$y", q], ["$D", F]].forEach(function(p) {
      me[p[1]] = function(o) {
        return this.$g(o, p[0], p[1]);
      };
    }), b.extend = function(p, o) {
      return p.$i || (p(o, te, b), p.$i = !0), b;
    }, b.locale = ee, b.isDayjs = le, b.unix = function(p) {
      return b(1e3 * p);
    }, b.en = P[R], b.Ls = P, b.p = {}, b;
  });
})(Ve);
var se = Ve.exports;
const y = /* @__PURE__ */ fe(se), A = (e, t, n) => {
  const i = `${e < 10 ? "0" : ""}${e}`, l = `${t < 10 ? "0" : ""}${t}`;
  return `${n}-${l}-${i}`;
}, re = (e, t) => {
  const n = `${e < 10 ? "0" : ""}${e}`, i = `${t < 10 ? "0" : ""}${t}`;
  return `${n}:${i}:00`;
}, ce = (e) => e.sort(
  (n, i) => n.unix() - i.unix()
);
var ke = { exports: {} };
(function(e, t) {
  (function(n, i) {
    e.exports = i();
  })(de, function() {
    return function(n, i, l) {
      i.prototype.isToday = function() {
        var $ = "YYYY-MM-DD", D = l();
        return this.format($) === D.format($);
      };
    };
  });
})(ke);
var Fe = ke.exports;
const Pe = /* @__PURE__ */ fe(Fe);
var we = { exports: {} };
(function(e, t) {
  (function(n, i) {
    e.exports = i();
  })(de, function() {
    return function(n, i, l) {
      var $ = i.prototype, D = function(h) {
        return h && (h.indexOf ? h : h.s);
      }, a = function(h, C, q, F, Q) {
        var U = h.name ? h : h.$locale(), ie = D(U[C]), ae = D(U[q]), E = ie || ae.map(function(R) {
          return R.slice(0, F);
        });
        if (!Q)
          return E;
        var oe = U.weekStart;
        return E.map(function(R, P) {
          return E[(P + (oe || 0)) % 7];
        });
      }, m = function() {
        return l.Ls[l.locale()];
      }, g = function(h, C) {
        return h.formats[C] || function(q) {
          return q.replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g, function(F, Q, U) {
            return Q || U.slice(1);
          });
        }(h.formats[C.toUpperCase()]);
      }, Z = function() {
        var h = this;
        return { months: function(C) {
          return C ? C.format("MMMM") : a(h, "months");
        }, monthsShort: function(C) {
          return C ? C.format("MMM") : a(h, "monthsShort", "months", 3);
        }, firstDayOfWeek: function() {
          return h.$locale().weekStart || 0;
        }, weekdays: function(C) {
          return C ? C.format("dddd") : a(h, "weekdays");
        }, weekdaysMin: function(C) {
          return C ? C.format("dd") : a(h, "weekdaysMin", "weekdays", 2);
        }, weekdaysShort: function(C) {
          return C ? C.format("ddd") : a(h, "weekdaysShort", "weekdays", 3);
        }, longDateFormat: function(C) {
          return g(h.$locale(), C);
        }, meridiem: this.$locale().meridiem, ordinal: this.$locale().ordinal };
      };
      $.localeData = function() {
        return Z.bind(this)();
      }, l.localeData = function() {
        var h = m();
        return { firstDayOfWeek: function() {
          return h.weekStart || 0;
        }, weekdays: function() {
          return l.weekdays();
        }, weekdaysShort: function() {
          return l.weekdaysShort();
        }, weekdaysMin: function() {
          return l.weekdaysMin();
        }, months: function() {
          return l.months();
        }, monthsShort: function() {
          return l.monthsShort();
        }, longDateFormat: function(C) {
          return g(h, C);
        }, meridiem: h.meridiem, ordinal: h.ordinal };
      }, l.months = function() {
        return a(m(), "months");
      }, l.monthsShort = function() {
        return a(m(), "monthsShort", "months", 3);
      }, l.weekdays = function(h) {
        return a(m(), "weekdays", null, null, h);
      }, l.weekdaysShort = function(h) {
        return a(m(), "weekdaysShort", "weekdays", 3, h);
      }, l.weekdaysMin = function(h) {
        return a(m(), "weekdaysMin", "weekdays", 2, h);
      };
    };
  });
})(we);
var Be = we.exports;
const Re = /* @__PURE__ */ fe(Be);
y.extend(Pe);
y.extend(Re);
const je = $e({
  emits: {
    change: (e) => !0,
    changeTime: (e) => !0,
    save: () => !0
  },
  props: {
    closeOnSelect: {
      required: !1,
      type: Boolean
    },
    datepickerElem: {
      required: !1,
      type: Object
    },
    inputWrapper: {
      required: !1,
      type: Object
    },
    max: {
      required: !1,
      type: String
    },
    min: {
      required: !1,
      type: String
    },
    range: {
      required: !1,
      type: Boolean
    },
    saveText: {
      required: !1,
      type: String
    },
    show: {
      required: !0,
      type: Boolean
    },
    type: {
      default: "date",
      required: !0,
      type: String
    },
    value: {
      required: !1,
      type: Object
    }
  },
  name: "sb-form-date-picker-popup",
  components: {
    "sb-button": Ye
  },
  data() {
    return {
      lastHoverDate: null,
      localShowContainer: "calendar",
      parentWithScroll: null,
      popupCurrentValue: {
        date: 0,
        hour: 0,
        minute: 0,
        month: 0,
        year: 0
      },
      popupStyles: {
        left: "0",
        top: "0"
      },
      selectedHourIndex: 0,
      selectedMinuteIndex: 0
    };
  },
  computed: {
    getDates() {
      const e = A(
        1,
        this.popupCurrentValue.month + 1,
        this.popupCurrentValue.year
      ), t = y(e), n = t.daysInMonth(), i = t.startOf("month").day(), l = t.subtract(1, "month").daysInMonth(), $ = [
        ...Array(n).keys()
      ].map((g) => ({
        value: g + 1
      })), D = [
        ...Array(i).keys()
      ].map((g) => ({
        disabled: !0,
        value: g + 1 + l - i,
        viewOnly: !0
      })), a = [
        ...Array(42 - (i + n)).keys()
      ].map((g) => ({
        disabled: !0,
        value: g + 1,
        viewOnly: !0
      }));
      return [
        ...D,
        ...$,
        ...a
      ];
    },
    getDays() {
      return y.weekdaysShort();
    },
    getFooterIcon() {
      return this.localShowContainer !== "calendar" && this.localShowContainer !== "hour-list" && this.localShowContainer !== "minute-list" ? ve() : Ce();
    },
    getYears() {
      const e = y().year(), t = Math.floor(e / 100) * 100;
      return [...Array(200).keys()].map(
        (i) => t - 100 + i + 1
      );
    },
    iconAngleDoubleLeft() {
      return Le();
    },
    iconAngleDoubleRight() {
      return qe();
    },
    iconAngleDown() {
      return He();
    },
    iconAngleLeft() {
      return Ie();
    },
    iconAngleRight() {
      return Ne();
    },
    iconAngleUp() {
      return Ae();
    },
    isSaveDisabled() {
      if (this.range) {
        const e = this.value;
        return !e || e && (e == null ? void 0 : e.length) < 2;
      }
      return !1;
    }
  },
  methods: {
    getDisplayTimeHour(e) {
      if (this.range) {
        const n = this.popupCurrentValue.hour[e];
        return `${n < 10 ? "0" : ""}${n}`;
      }
      const t = this.popupCurrentValue.hour;
      return `${t < 10 ? "0" : ""}${t}`;
    },
    getDisplayTimeMinute(e) {
      if (this.range) {
        const n = this.popupCurrentValue.minute[e];
        return `${n < 10 ? "0" : ""}${n}`;
      }
      const t = this.popupCurrentValue.minute;
      return `${t < 10 ? "0" : ""}${t}`;
    },
    getMonthText(e, t = !1) {
      return t ? y.monthsShort()[e] : y.months()[e];
    },
    handleClickHour(e) {
      this.range ? this.popupCurrentValue.hour[this.selectedHourIndex] = e : this.popupCurrentValue.hour = e, this.localShowContainer = "time", this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleClickMinute(e) {
      this.range ? this.popupCurrentValue.minute[this.selectedMinuteIndex] = e : this.popupCurrentValue.minute = e, this.localShowContainer = "time", this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleClickMonth(e) {
      this.popupCurrentValue.month = e, this.localShowContainer = "calendar", this.$nextTick(() => {
        if (this.type === "month") {
          const t = A(
            1,
            this.popupCurrentValue.month + 1,
            y().year()
          );
          this.$emit("change", y(t));
        }
      });
    },
    handleClickYear(e) {
      this.popupCurrentValue.year = e, this.localShowContainer = "calendar", this.$nextTick(() => {
        if (this.type === "year") {
          const t = A(
            1,
            1,
            this.popupCurrentValue.year
          );
          this.$emit("change", y(t));
        }
      });
    },
    handleDateMouseover({ disabled: e, value: t }) {
      if (!this.isDateDisabled(t) && !e && this.value && this.value.length < 2) {
        const n = A(
          t,
          this.popupCurrentValue.month + 1,
          this.popupCurrentValue.year
        );
        this.lastHoverDate = y(n);
      }
    },
    handleFooterClick() {
      this.localShowContainer !== "calendar" && this.localShowContainer !== "hour-list" && this.localShowContainer !== "minute-list" ? this.localShowContainer = "calendar" : this.localShowContainer = "time";
    },
    handleNavMonth(e) {
      e < 0 ? this.popupCurrentValue.month < 1 ? (this.popupCurrentValue.month = 11, this.popupCurrentValue.year -= 1) : this.popupCurrentValue.month -= 1 : this.popupCurrentValue.month > 10 ? (this.popupCurrentValue.month = 0, this.popupCurrentValue.year += 1) : this.popupCurrentValue.month += 1;
    },
    handleNavTime(e, t, n) {
      this.range ? this.handleNavTimeRange(e, t, n) : this.handleNavTimeNotRange(e, t);
    },
    handleNavTimeNotRange(e, t) {
      const n = this.popupCurrentValue.hour, i = this.popupCurrentValue.minute;
      t === "hour" ? e < 0 ? n < 1 ? this.popupCurrentValue.hour = 23 : this.popupCurrentValue.hour += e : n > 22 ? this.popupCurrentValue.hour = 0 : this.popupCurrentValue.hour += e : e < 0 ? i < 1 ? this.popupCurrentValue.minute = 59 : this.popupCurrentValue.minute += e : i > 58 ? this.popupCurrentValue.minute = 0 : this.popupCurrentValue.minute += e, this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleNavTimeRange(e, t, n) {
      const i = this.popupCurrentValue.hour[n], l = this.popupCurrentValue.minute[0];
      t === "hour" ? e < 0 ? i < 1 ? this.popupCurrentValue.hour[n] = 23 : this.popupCurrentValue.hour[n] += e : i > 22 ? this.popupCurrentValue.hour[n] = 0 : this.popupCurrentValue.hour[n] += e : e < 0 ? l < 1 ? this.popupCurrentValue.minute[n] = 59 : this.popupCurrentValue.minute[n] += e : l > 58 ? this.popupCurrentValue.minute[n] = 0 : this.popupCurrentValue.minute[n] += e, this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleNavYear(e) {
      this.popupCurrentValue.year += e;
    },
    handleParentScroll(e) {
      const t = ge(this.$el);
      this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
        this.setPopupPosition();
      }), t && (e ? t.addEventListener("scroll", () => {
        this.setPopupPosition();
      }) : t.removeEventListener("scroll", () => {
        this.setPopupPosition();
      })), this.$nextTick(() => {
        this.parentWithScroll = t;
      });
    },
    handleSave() {
      if (this.type === "time")
        this.setModelValueTime();
      else if (this.type === "month") {
        const e = A(
          1,
          this.popupCurrentValue.month + 1,
          y().year()
        );
        this.$emit("change", y(e));
      } else if (this.type === "year") {
        const e = A(
          1,
          1,
          this.popupCurrentValue.year
        );
        this.$emit("change", y(e));
      } else
        (!this.range || this.range && (!this.value || this.value.length < 2)) && this.setModelValueDate(this.popupCurrentValue.date);
      this.$emit("save");
    },
    handleSelectDate({ disabled: e, value: t }) {
      !e && !this.isDateDisabled(t) && (this.popupCurrentValue.date = t, this.setModelValueDate(t));
    },
    handleShowHourList(e) {
      const t = this.$refs[`hour-${this.popupCurrentValue.hour}`];
      (t == null ? void 0 : t.length) > 0 && t[0].scrollIntoView({
        block: "center"
      }), this.selectedHourIndex = e, this.localShowContainer = "hour-list";
    },
    handleShowMinuteList(e) {
      const t = this.$refs[`minute-${this.popupCurrentValue.minute}`];
      (t == null ? void 0 : t.length) > 0 && t[0].scrollIntoView({
        block: "center"
      }), this.selectedMinuteIndex = e, this.localShowContainer = "minute-list";
    },
    handleShowMonthList() {
      this.localShowContainer = "month-list";
    },
    handleShowYearList() {
      const e = this.$refs[`year-${this.popupCurrentValue.year}`];
      (e == null ? void 0 : e.length) > 0 && e[0].scrollIntoView({
        block: "center"
      }), this.localShowContainer = "year-list";
    },
    isCurrentDate({ value: e, viewOnly: t }) {
      if (this.popupCurrentValue.year !== null && this.popupCurrentValue.month !== null && !t) {
        const n = A(
          e,
          this.popupCurrentValue.month + 1,
          this.popupCurrentValue.year
        );
        return y(n).isToday();
      }
      return !1;
    },
    isDateDisabled(e) {
      const t = A(
        e,
        this.popupCurrentValue.month + 1,
        this.popupCurrentValue.year
      );
      if (this.max || this.min) {
        const n = () => this.max ? y(this.max).endOf("day").diff(y(t)) <= 0 : !1, i = () => {
          if (this.min) {
            const l = y(this.min).subtract(1, "day").startOf("day");
            return y(t).diff(l) <= 0;
          }
          return !1;
        };
        return n() || i();
      }
      return !1;
    },
    isDateInRange({ value: e }) {
      if (this.value && this.range) {
        const t = [...this.value], n = () => t.length > 1 ? t : this.lastHoverDate ? [...t, this.lastHoverDate] : [];
        if (this.lastHoverDate || t.length > 1) {
          const i = A(
            e,
            this.popupCurrentValue.month + 1,
            this.popupCurrentValue.year
          ), l = ce(
            n()
          ), $ = y(i);
          return $.unix() >= l[0].unix() && $.unix() <= l[1].unix();
        }
      }
      return !1;
    },
    isDateSelected({ value: e, viewOnly: t }) {
      if (this.popupCurrentValue.year !== null && this.popupCurrentValue.month !== null && !t && this.value) {
        const n = A(
          e,
          this.popupCurrentValue.month + 1,
          this.popupCurrentValue.year
        );
        return this.range ? [
          ...this.value || []
        ].some((l) => y(n).startOf("day").diff(l.startOf("day")) === 0) : y(n).startOf("day").diff(this.value.startOf("day")) === 0;
      }
      return !1;
    },
    isHourSelected(e) {
      return this.popupCurrentValue.hour === e;
    },
    isMinuteSelected(e) {
      return this.popupCurrentValue.minute === e;
    },
    isMonthSelected(e) {
      return this.popupCurrentValue.month === e;
    },
    isYearSelected(e) {
      return this.popupCurrentValue.year === e;
    },
    setModelValueDate(e) {
      const t = A(
        e,
        this.popupCurrentValue.month + 1,
        this.popupCurrentValue.year
      );
      if (this.type === "datetime")
        if (this.range) {
          const n = !this.value || this.value && this.value.length > 1 ? 0 : 1, i = this.popupCurrentValue.hour[n], l = this.popupCurrentValue.minute[n], $ = re(
            i,
            l
          );
          this.$emit(
            "change",
            y(`${t} ${$}`)
          );
        } else {
          const n = this.popupCurrentValue.hour, i = this.popupCurrentValue.minute, l = re(
            n,
            i
          );
          this.$emit(
            "change",
            y(`${t} ${l}`)
          );
        }
      else
        this.$emit("change", y(t));
    },
    setModelValueTime() {
      if (this.range) {
        const t = [...this.value || [
          y(),
          y()
        ]].map(
          (n, i) => {
            const l = this.popupCurrentValue.hour[i], $ = this.popupCurrentValue.minute[i], D = re(
              l,
              $
            ), a = `${n.format(
              "YYYY-MM-DD"
            )} ${D}`;
            return y(a);
          }
        );
        this.$emit("changeTime", t);
      } else {
        const e = this.value || y(), t = this.popupCurrentValue.hour, n = this.popupCurrentValue.minute, i = re(t, n), l = `${e.format(
          "YYYY-MM-DD"
        )} ${i}`;
        this.$emit("change", y(l));
      }
    },
    setPopupPosition() {
      if (this.inputWrapper && this.$refs["popup-wrapper"]) {
        const t = this.inputWrapper.getBoundingClientRect(), n = this.$refs["popup-wrapper"].getBoundingClientRect(), i = document.body.getBoundingClientRect().height - (t.height + t.y) <= n.height, l = () => t.width > n.width || t.width < n.width ? t.x + (t.width - n.width) / 2 : t.x;
        i ? this.popupStyles = {
          left: `${l() + 2}px`,
          top: `${t.y - 6 - n.height}px`
        } : this.popupStyles = {
          left: `${l() + 2}px`,
          top: `${t.y + t.height}px`
        }, this.$nextTick(() => {
          const $ = this.$refs[`year-${this.popupCurrentValue.year}`];
          ($ == null ? void 0 : $.length) > 0 && $[0].scrollIntoView({
            block: "center"
          });
        });
      }
    },
    setPopupValue() {
      if (this.value)
        if (this.range) {
          const e = this.value, t = [...e].map(
            ($) => $.minute()
          ), n = [...e].map(
            ($) => $.hour()
          ), i = this.popupCurrentValue.hour[this.popupCurrentValue.hour.length - 1], l = this.popupCurrentValue.minute[this.popupCurrentValue.minute.length - 1];
          this.popupCurrentValue = {
            date: e[e.length - 1].date(),
            hour: [
              ...n,
              ...e.length < 2 ? [i] : []
            ],
            minute: [
              ...t,
              ...e.length < 2 ? [l] : []
            ],
            month: e[e.length - 1].month(),
            year: e[e.length - 1].year()
          };
        } else {
          const e = this.value;
          this.popupCurrentValue = {
            date: e.date(),
            hour: e.hour(),
            minute: e.minute(),
            month: e.month(),
            year: e.year()
          };
        }
      else {
        const e = y();
        this.popupCurrentValue = {
          date: e.date(),
          hour: this.range ? [e.hour(), e.hour()] : e.hour(),
          minute: this.range ? [e.minute(), e.minute()] : e.minute(),
          month: e.month(),
          year: e.year()
        };
      }
    }
  },
  watch: {
    show(e, t) {
      this.handleParentScroll(e), t && !e ? (this.setPopupValue(), this.type === "time" ? this.localShowContainer = "time" : this.localShowContainer = "calendar") : !t && e && this.$nextTick(() => this.setPopupPosition());
    },
    type: {
      handler(e) {
        e === "time" ? this.localShowContainer = "time" : this.localShowContainer = "calendar";
      },
      immediate: !0
    },
    value: {
      deep: !0,
      handler() {
        this.setPopupValue();
      },
      immediate: !0
    }
  },
  mounted() {
    this.setPopupPosition(), this.parentWithScroll = ge(
      this.datepickerElem
    );
  },
  unmounted() {
    this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
      this.setPopupPosition();
    });
  }
}), Ue = {
  key: 0,
  class: "month-list-wrapper"
}, Ee = ["onClick"], Ge = {
  key: 1,
  class: "year-list-wrapper"
}, ze = ["onClick"], Je = { class: "hour-list-wrapper" }, Ke = ["onClick"], Ze = { class: "minute-list-wrapper" }, Qe = ["onClick"], Xe = {
  key: 3,
  class: "header"
}, _e = { class: "nav-wrapper" }, xe = { class: "current" }, et = { class: "nav-wrapper" }, tt = {
  key: 4,
  class: "body"
}, nt = { class: "days-wrapper" }, rt = { class: "dates-wrapper" }, st = ["onClick", "onMouseover"], it = {
  key: 1,
  class: "time-wrapper"
}, at = { class: "value-wrapper" }, ot = { class: "time-nav" }, lt = ["onClick"], ut = { class: "time-nav down" }, ht = /* @__PURE__ */ k("div", { class: "separator" }, ":", -1), pt = { class: "value-wrapper" }, ct = { class: "time-nav" }, dt = ["onClick"], ft = { class: "time-nav down" };
function mt(e, t, n, i, l, $) {
  const D = he("sb-button");
  return f(), L(De, { to: "body" }, [
    e.show ? (f(), V("div", {
      key: 0,
      class: J(["sb-datepicker-popup-wrapper", [
        `container-${e.localShowContainer}`,
        e.type,
        e.range ? "range" : "",
        e.show ? "show" : "",
        e.type === "time" ? "time-only" : "",
        e.closeOnSelect ? "" : "with-save"
      ]]),
      ref: "popup-wrapper",
      style: Me(e.popupStyles)
    }, [
      e.type !== "time" && e.type !== "year" ? (f(), V("div", Ue, [
        (f(!0), V(B, null, K([...Array(12).keys()], (a, m) => (f(), V("div", {
          class: J(["month", {
            selected: e.isMonthSelected(a)
          }]),
          key: `month-${m}`,
          onClick: M((g) => e.handleClickMonth(a), ["stop"])
        }, I(e.getMonthText(a, !0)), 11, Ee))), 128))
      ])) : N("", !0),
      e.type !== "time" && e.type !== "month" ? (f(), V("div", Ge, [
        (f(!0), V(B, null, K(e.getYears, (a, m) => (f(), V("div", {
          class: J(["year", {
            selected: e.isYearSelected(a)
          }]),
          key: `year-${m}`,
          ref_for: !0,
          ref: `year-${a}`,
          onClick: M((g) => e.handleClickYear(a), ["stop"])
        }, I(a), 11, ze))), 128))
      ])) : N("", !0),
      e.type === "time" || e.type === "datetime" ? (f(), V(B, { key: 2 }, [
        k("div", Je, [
          (f(!0), V(B, null, K([...Array(24).keys()], (a, m) => (f(), V("div", {
            class: J(["hour", {
              selected: e.isHourSelected(a)
            }]),
            key: `hour-${m}`,
            ref_for: !0,
            ref: `hour-${a}`,
            onClick: M((g) => e.handleClickHour(a), ["stop"])
          }, I(`${a < 10 ? "0" : ""}${a}`), 11, Ke))), 128))
        ]),
        k("div", Ze, [
          (f(!0), V(B, null, K([...Array(60).keys()], (a, m) => (f(), V("div", {
            class: J(["minute", {
              selected: e.isMinuteSelected(a)
            }]),
            key: `minute-${m}`,
            ref_for: !0,
            ref: `minute-${a}`,
            onClick: M((g) => e.handleClickMinute(a), ["stop"])
          }, I(`${a < 10 ? "0" : ""}${a}`), 11, Qe))), 128))
        ])
      ], 64)) : N("", !0),
      e.type !== "time" && e.type !== "month" && e.type !== "year" ? (f(), V("div", Xe, [
        k("div", _e, [
          k("div", {
            class: "nav",
            onClick: t[0] || (t[0] = M((a) => e.handleNavYear(-1), ["stop"]))
          }, [
            (f(), L(W(e.iconAngleDoubleLeft)))
          ]),
          k("div", {
            class: "nav",
            onClick: t[1] || (t[1] = M((a) => e.handleNavMonth(-1), ["stop"]))
          }, [
            (f(), L(W(e.iconAngleLeft)))
          ])
        ]),
        k("div", xe, [
          k("div", {
            class: "year",
            onClick: t[2] || (t[2] = M((...a) => e.handleShowYearList && e.handleShowYearList(...a), ["stop"]))
          }, I(e.popupCurrentValue.year), 1),
          k("div", {
            class: "month",
            onClick: t[3] || (t[3] = M((...a) => e.handleShowMonthList && e.handleShowMonthList(...a), ["stop"]))
          }, I(e.getMonthText(e.popupCurrentValue.month)), 1)
        ]),
        k("div", et, [
          k("div", {
            class: "nav",
            onClick: t[4] || (t[4] = M((a) => e.handleNavMonth(1), ["stop"]))
          }, [
            (f(), L(W(e.iconAngleRight)))
          ]),
          k("div", {
            class: "nav",
            onClick: t[5] || (t[5] = M((a) => e.handleNavYear(1), ["stop"]))
          }, [
            (f(), L(W(e.iconAngleDoubleRight)))
          ])
        ])
      ])) : N("", !0),
      e.type !== "month" && e.type !== "year" ? (f(), V("div", tt, [
        e.type !== "time" ? (f(), V(B, { key: 0 }, [
          k("div", nt, [
            (f(!0), V(B, null, K(e.getDays, (a, m) => (f(), V("div", {
              class: "day",
              key: `day-${m}`
            }, I(a), 1))), 128))
          ]),
          k("div", rt, [
            (f(!0), V(B, null, K(e.getDates, (a, m) => (f(), V("div", {
              class: J(["date", {
                "in-range": e.isDateInRange(a),
                current: e.isCurrentDate(a),
                disabled: a.disabled || e.isDateDisabled(a.value),
                selected: e.isDateSelected(a)
              }]),
              key: `date-${m}`,
              onClick: M((g) => e.handleSelectDate(a), ["stop"]),
              onMouseover: (g) => e.handleDateMouseover(a)
            }, I(a.value), 43, st))), 128))
          ])
        ], 64)) : N("", !0),
        e.type !== "date" ? (f(), V("div", it, [
          (f(!0), V(B, null, K(e.range ? [0, 1] : [0], (a, m) => (f(), V("div", {
            class: "time",
            key: `time-picker-${m}`
          }, [
            k("div", at, [
              k("div", ot, [
                (f(), L(W(e.iconAngleUp), {
                  onClick: M((g) => e.handleNavTime(1, "hour", m), ["stop"])
                }, null, 8, ["onClick"]))
              ]),
              k("div", {
                class: "value",
                onClick: M((g) => e.handleShowHourList(m), ["stop"])
              }, I(e.getDisplayTimeHour(m)), 9, lt),
              k("div", ut, [
                (f(), L(W(e.iconAngleDown), {
                  onClick: M((g) => e.handleNavTime(-1, "hour", m), ["stop"])
                }, null, 8, ["onClick"]))
              ])
            ]),
            ht,
            k("div", pt, [
              k("div", ct, [
                (f(), L(W(e.iconAngleUp), {
                  onClick: M((g) => e.handleNavTime(1, "minute", m), ["stop"])
                }, null, 8, ["onClick"]))
              ]),
              k("div", {
                class: "value",
                onClick: M((g) => e.handleShowMinuteList(m), ["stop"])
              }, I(e.getDisplayTimeMinute(m)), 9, dt),
              k("div", ft, [
                (f(), L(W(e.iconAngleDown), {
                  onClick: M((g) => e.handleNavTime(-1, "minute", m), ["stop"])
                }, null, 8, ["onClick"]))
              ])
            ])
          ]))), 128))
        ])) : N("", !0)
      ])) : N("", !0),
      !e.closeOnSelect || e.type === "datetime" ? (f(), V("div", {
        key: 5,
        class: J(["footer", {
          "two-button": !e.closeOnSelect && e.type === "datetime"
        }])
      }, [
        e.type === "datetime" ? (f(), L(D, {
          key: 0,
          "no-elevation": "",
          class: "button-time",
          color: "secondary",
          tabindex: "-1",
          type: "button",
          variant: "text",
          onClick: M(e.handleFooterClick, ["stop"])
        }, {
          default: pe(() => [
            (f(), L(W(e.getFooterIcon)))
          ]),
          _: 1
        }, 8, ["onClick"])) : N("", !0),
        e.closeOnSelect ? N("", !0) : (f(), L(D, {
          key: 1,
          disabled: e.isSaveDisabled,
          "no-elevation": "",
          color: "accent",
          tabindex: "-1",
          type: "button",
          variant: "text",
          onClick: M(e.handleSave, ["stop"])
        }, {
          default: pe(() => [
            be(I(e.saveText || "Save"), 1)
          ]),
          _: 1
        }, 8, ["disabled", "onClick"]))
      ], 2)) : N("", !0)
    ], 6)) : N("", !0)
  ]);
}
const yt = /* @__PURE__ */ Se(je, [["render", mt]]), gt = $e({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0,
    input: (e) => !0
  },
  props: {
    allowClear: {
      required: !1,
      type: Boolean
    },
    closeOnSelect: {
      required: !1,
      type: Boolean
    },
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    format: {
      required: !1,
      type: String
    },
    isError: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    max: {
      required: !1,
      type: String
    },
    min: {
      required: !1,
      type: String
    },
    modelValue: {
      required: !1,
      type: String
    },
    noIcon: {
      required: !1,
      type: Boolean
    },
    placeholder: {
      required: !1,
      type: String
    },
    range: {
      required: !1,
      type: Boolean
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    saveText: {
      required: !1,
      type: String
    },
    type: {
      default: "date",
      required: !1,
      type: String
    },
    value: {
      required: !1,
      type: String
    },
    variant: {
      default: "default",
      required: !1,
      type: String
    }
  },
  name: "sb-form-date-picker",
  components: {
    "sb-input": Oe,
    "sb-datepicker-popup": yt
  },
  data() {
    return {
      datepickerWrapper: null,
      icon: {
        onClick: null,
        placement: "append"
      },
      inputWrapper: null,
      localValue: null,
      localShow: !1,
      valueString: null
    };
  },
  computed: {
    getIcon() {
      return this.allowClear && this.localValue && this.localValue !== "" ? We() : this.type === "time" ? Ce() : ve();
    }
  },
  methods: {
    emitFinalValue() {
      if (typeof this.localValue == "object" && this.localValue.length) {
        const e = [
          ...this.localValue
        ].map((t) => t.toISOString());
        this.$emit("update:modelValue", e), this.$emit("input", e), this.$emit("change", e);
      } else {
        const e = this.localValue.toISOString();
        this.$emit("update:modelValue", e), this.$emit("input", e), this.$emit("change", e);
      }
    },
    getDefaultFormat() {
      switch (this.type) {
        case "datetime":
          return "YYYY-MM-DD HH:mm:ss";
        case "time":
          return "HH:mm:ss";
        case "month":
          return "YYYY-MM";
        case "year":
          return "YYYY";
        default:
          return "YYYY-MM-DD";
      }
    },
    handleClickIcon() {
      return this.allowClear && this.localValue && this.localValue !== "" ? this.handleUpdateModelValue(null) : !this.disabled && !this.readOnly ? this.handleOpenCalendar() : null;
    },
    handleClickOutsideDatepicker(e) {
      const t = e.target, n = this.$refs["datepicker-wrapper"];
      t && n && !n.contains(t) && !t.isSameNode(n) && (this.localShow = !1);
    },
    handleGenerateString() {
      if (!this.range)
        this.localValue && (this.format ? this.valueString = this.localValue.format(
          this.format
        ) : this.valueString = this.localValue.format(
          this.getDefaultFormat()
        ));
      else {
        const e = [...this.localValue];
        e && (this.format ? this.valueString = e.map((t) => t.format(this.format)).join(" - ") : this.valueString = e.map(
          (t) => t.format(this.getDefaultFormat())
        ).join(" - "));
      }
    },
    handleKeyDown(e) {
      const t = e;
      t.key === "Backspace" ? this.handleUpdateModelValue(null) : t.key === "Tab" ? (this.localShow = !1, this.$el.blur()) : e.preventDefault();
    },
    handleOnChange(e) {
      if (!this.range)
        this.handleUpdateModelValue(e);
      else {
        const n = ce((() => this.localValue && this.localValue.length === 1 ? [...this.localValue, e] : [e])());
        this.localValue = [...n], this.$nextTick(() => {
          this.localValue.length > 1 && this.handleRangeUpdateModelValue();
        });
      }
    },
    handleOnChangeTime(e) {
      const t = ce(e);
      this.localValue = [...t], this.$nextTick(() => this.handleRangeUpdateModelValue());
    },
    handleOnSave() {
      this.localShow = !1, this.$nextTick(() => {
        this.handleGenerateString(), this.emitFinalValue();
      });
    },
    handleOpenCalendar() {
      if (!this.disabled && !this.readOnly) {
        const t = this.$el.getElementsByTagName("input");
        if ((t == null ? void 0 : t.length) > 0) {
          const n = t.item(0);
          n == null || n.focus();
        }
        this.localShow = !0;
      }
    },
    handleUpdateModelValue(e) {
      this.localValue = e, this.closeOnSelect && (this.localShow = !1, this.$nextTick(() => {
        this.handleGenerateString(), this.emitFinalValue();
      }));
    },
    handleRangeUpdateModelValue() {
      this.closeOnSelect && (this.localShow = !1, this.$nextTick(() => {
        this.handleGenerateString(), this.emitFinalValue();
      }));
    },
    setLocalValue(e) {
      if (!e || (e == null ? void 0 : e.length) < 1)
        this.valueString = null, this.localValue = null;
      else if (this.range) {
        const t = [
          se.isDayjs(e[0]) ? e[0] : y(e[0]),
          se.isDayjs(e[1]) ? e[1] : y(e[1])
        ];
        if ([...t].some(
          (i) => !i.isValid()
        ))
          this.valueString = null, this.localValue = null;
        else {
          if (this.format) {
            const i = t[1].format(
              this.format
            ), l = t[0].format(
              this.format
            );
            this.valueString = `${l} - ${i}`;
          } else {
            const i = t[1].format(
              this.getDefaultFormat()
            ), l = t[0].format(
              this.getDefaultFormat()
            );
            this.valueString = `${l} - ${i}`;
          }
          this.localValue = t;
        }
      } else {
        const t = se.isDayjs(e) ? e : y(e);
        t.isValid() ? (this.format ? this.valueString = t.format(
          this.format
        ) : this.valueString = t.format(
          this.getDefaultFormat()
        ), this.localValue = t) : (this.valueString = null, this.localValue = null);
      }
    }
  },
  watch: {
    localShow(e, t) {
      if (!e && t && this.range && (!this.localValue || this.localValue && this.localValue.length < 2))
        this.localValue = null;
      else if (!e) {
        const i = this.$el.getElementsByTagName("input");
        if ((i == null ? void 0 : i.length) > 0) {
          const l = i.item(0);
          l == null || l.blur();
        }
      }
    },
    modelValue: {
      deep: !0,
      handler(e) {
        this.setLocalValue(e);
      }
    },
    value: {
      deep: !0,
      handler(e) {
        this.setLocalValue(e);
      }
    }
  },
  mounted() {
    this.setLocalValue(this.modelValue || this.value), this.icon.onClick = this.handleClickIcon;
    const e = this.$refs["input-wrapper"].$el.children, t = Array.from(e).find(
      (n) => n.classList.contains("input-group")
    );
    this.inputWrapper = t, document.addEventListener(
      "click",
      (n) => this.handleClickOutsideDatepicker(n)
    ), this.setLocalValue(this.localValue), this.datepickerWrapper = this.$el;
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClickOutsideDatepicker(e)
    );
  }
});
const $t = ["tabindex"];
function vt(e, t, n, i, l, $) {
  const D = he("sb-input"), a = he("sb-datepicker-popup");
  return f(), V("div", ue({
    class: [{ error: e.isError, range: e.range }, "datepicker-wrapper"],
    tabindex: !e.disabled && !e.readOnly ? 0 : -1,
    ref: "datepicker-wrapper"
  }, { ...e.$attrs }, {
    onBlur: t[1] || (t[1] = () => e.localShow = !1),
    onFocus: t[2] || (t[2] = () => e.handleOpenCalendar())
  }), [
    ye(D, ue({
      "error-message": e.errorMessage,
      "is-error": e.isError,
      "is-focus": e.localShow,
      label: e.label,
      placeholder: e.placeholder,
      tabindex: -1,
      value: e.valueString,
      variant: e.variant,
      ref: "input-wrapper",
      type: "text"
    }, {
      disabled: e.disabled,
      required: e.required,
      readOnly: e.readOnly,
      ...!e.noIcon && {
        icon: e.icon
      }
    }, {
      onFocus: t[0] || (t[0] = () => e.handleOpenCalendar()),
      onKeydown: e.handleKeyDown
    }), Te({ _: 2 }, [
      e.noIcon ? void 0 : {
        name: "icon-slot",
        fn: pe(() => [
          (f(), L(W(e.getIcon)))
        ]),
        key: "0"
      }
    ]), 1040, ["error-message", "is-error", "is-focus", "label", "placeholder", "value", "variant", "onKeydown"]),
    ye(a, ue({
      "datepicker-elem": e.datepickerWrapper,
      "close-on-select": e.closeOnSelect,
      "input-wrapper": e.inputWrapper,
      show: e.localShow,
      value: e.localValue
    }, {
      max: e.max,
      min: e.min,
      range: e.range,
      saveText: e.saveText,
      type: e.type
    }, {
      onChange: e.handleOnChange,
      onChangeTime: e.handleOnChangeTime,
      onSave: e.handleOnSave
    }), null, 16, ["datepicker-elem", "close-on-select", "input-wrapper", "show", "value", "onChange", "onChangeTime", "onSave"])
  ], 16, $t);
}
const Tt = /* @__PURE__ */ Se(gt, [["render", vt]]);
export {
  Tt as default
};
