import "./color-picker.css";
import { defineComponent as o, openBlock as t, createElementBlock as l, mergeProps as i, createElementVNode as r, toDisplayString as d, createCommentVNode as n, Fragment as c, renderList as u, normalizeClass as p, normalizeStyle as m } from "vue";
import { _ as h } from "../../_plugin-vue_export-helper-dad06003.js";
const _ = o({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0
  },
  props: {
    label: {
      required: !1,
      type: String
    },
    list: {
      required: !0,
      type: Object
    },
    modelValue: {
      required: !1,
      type: String
    },
    value: {
      required: !1,
      type: String
    }
  },
  name: "sb-color-picker",
  data() {
    return {
      selected: this.modelValue || this.value || null
    };
  },
  methods: {
    doSelect(e) {
      this.selected = e, this.$nextTick(() => {
        this.$emit("update:modelValue", this.selected), this.$emit("change", this.selected);
      });
    },
    isSelected(e) {
      return this.selected ? this.selected === e : !1;
    }
  },
  watch: {
    modelValue: {
      deep: !0,
      handler(e) {
        this.selected = e;
      }
    },
    value: {
      deep: !0,
      handler(e) {
        this.selected = e;
      }
    }
  }
});
const f = {
  key: 0,
  class: "label"
}, g = { class: "input-group colors-wrapper" }, k = ["onClick"];
function y(e, v, S, $, b, V) {
  return t(), l("div", i({ class: "color-wrapper" }, { ...e.$attrs }), [
    e.label ? (t(), l("label", f, [
      r("span", null, d(e.label), 1)
    ])) : n("", !0),
    r("div", g, [
      (t(!0), l(c, null, u(e.list, (s, a) => (t(), l("div", {
        class: p([{
          selected: e.isSelected(s)
        }, "color"]),
        key: a,
        style: m({ background: s }),
        onClick: (C) => e.doSelect(s)
      }, null, 14, k))), 128))
    ])
  ], 16);
}
const P = /* @__PURE__ */ h(_, [["render", y], ["__scopeId", "data-v-7107f390"]]);
export {
  P as default
};
