import "./organization-tree.css";
import { defineComponent as rt, openBlock as g, createElementBlock as y, Fragment as x, normalizeClass as F, normalizeStyle as X, withModifiers as f, renderList as O, createElementVNode as E, toDisplayString as j, createCommentVNode as M, resolveComponent as V, mergeProps as G, createBlock as Q, createVNode as ft, Teleport as pt } from "vue";
import yt from "../form-dropdown/form-dropdown.js";
import { _ as at } from "../../_plugin-vue_export-helper-dad06003.js";
import "../progress-circular/progress-circular.js";
import "../form-input/form-input.js";
import "../../icons-fca12ed8.js";
import "../../helper-4d4ed314.js";
function St(t, e) {
  if (t.match(/^[a-z]+:\/\//i))
    return t;
  if (t.match(/^\/\//))
    return window.location.protocol + t;
  if (t.match(/^[a-z]+:/i))
    return t;
  const n = document.implementation.createHTMLDocument(), o = n.createElement("base"), i = n.createElement("a");
  return n.head.appendChild(o), n.body.appendChild(i), e && (o.href = e), i.href = t, i.href;
}
const $t = (() => {
  let t = 0;
  const e = () => (
    // eslint-disable-next-line no-bitwise
    `0000${(Math.random() * 36 ** 4 << 0).toString(36)}`.slice(-4)
  );
  return () => (t += 1, `u${e()}${t}`);
})();
function T(t) {
  const e = [];
  for (let n = 0, o = t.length; n < o; n++)
    e.push(t[n]);
  return e;
}
function Y(t, e) {
  const o = (t.ownerDocument.defaultView || window).getComputedStyle(t).getPropertyValue(e);
  return o ? parseFloat(o.replace("px", "")) : 0;
}
function Ct(t) {
  const e = Y(t, "border-left-width"), n = Y(t, "border-right-width");
  return t.clientWidth + e + n;
}
function Pt(t) {
  const e = Y(t, "border-top-width"), n = Y(t, "border-bottom-width");
  return t.clientHeight + e + n;
}
function ct(t, e = {}) {
  const n = e.width || Ct(t), o = e.height || Pt(t);
  return { width: n, height: o };
}
function wt() {
  let t, e;
  try {
    e = process;
  } catch {
  }
  const n = e && e.env ? e.env.devicePixelRatio : null;
  return n && (t = parseInt(n, 10), Number.isNaN(t) && (t = 1)), t || window.devicePixelRatio || 1;
}
const v = 16384;
function vt(t) {
  (t.width > v || t.height > v) && (t.width > v && t.height > v ? t.width > t.height ? (t.height *= v / t.width, t.width = v) : (t.width *= v / t.height, t.height = v) : t.width > v ? (t.height *= v / t.width, t.width = v) : (t.width *= v / t.height, t.height = v));
}
function B(t) {
  return new Promise((e, n) => {
    const o = new Image();
    o.decode = () => e(o), o.onload = () => e(o), o.onerror = n, o.crossOrigin = "anonymous", o.decoding = "async", o.src = t;
  });
}
async function bt(t) {
  return Promise.resolve().then(() => new XMLSerializer().serializeToString(t)).then(encodeURIComponent).then((e) => `data:image/svg+xml;charset=utf-8,${e}`);
}
async function kt(t, e, n) {
  const o = "http://www.w3.org/2000/svg", i = document.createElementNS(o, "svg"), s = document.createElementNS(o, "foreignObject");
  return i.setAttribute("width", `${e}`), i.setAttribute("height", `${n}`), i.setAttribute("viewBox", `0 0 ${e} ${n}`), s.setAttribute("width", "100%"), s.setAttribute("height", "100%"), s.setAttribute("x", "0"), s.setAttribute("y", "0"), s.setAttribute("externalResourcesRequired", "true"), i.appendChild(s), s.appendChild(t), bt(i);
}
const P = (t, e) => {
  if (t instanceof e)
    return !0;
  const n = Object.getPrototypeOf(t);
  return n === null ? !1 : n.constructor.name === e.name || P(n, e);
};
function Et(t) {
  const e = t.getPropertyValue("content");
  return `${t.cssText} content: '${e.replace(/'|"/g, "")}';`;
}
function Tt(t) {
  return T(t).map((e) => {
    const n = t.getPropertyValue(e), o = t.getPropertyPriority(e);
    return `${e}: ${n}${o ? " !important" : ""};`;
  }).join(" ");
}
function xt(t, e, n) {
  const o = `.${t}:${e}`, i = n.cssText ? Et(n) : Tt(n);
  return document.createTextNode(`${o}{${i}}`);
}
function _(t, e, n) {
  const o = window.getComputedStyle(t, n), i = o.getPropertyValue("content");
  if (i === "" || i === "none")
    return;
  const s = $t();
  try {
    e.className = `${e.className} ${s}`;
  } catch {
    return;
  }
  const r = document.createElement("style");
  r.appendChild(xt(s, n, o)), e.appendChild(r);
}
function It(t, e) {
  _(t, e, ":before"), _(t, e, ":after");
}
const tt = "application/font-woff", et = "image/jpeg", Rt = {
  woff: tt,
  woff2: tt,
  ttf: "application/font-truetype",
  eot: "application/vnd.ms-fontobject",
  png: "image/png",
  jpg: et,
  jpeg: et,
  gif: "image/gif",
  tiff: "image/tiff",
  svg: "image/svg+xml",
  webp: "image/webp"
};
function Lt(t) {
  const e = /\.([^./]*?)$/g.exec(t);
  return e ? e[1] : "";
}
function K(t) {
  const e = Lt(t).toLowerCase();
  return Rt[e] || "";
}
function Dt(t) {
  return t.split(/,/)[1];
}
function J(t) {
  return t.search(/^(data:)/) !== -1;
}
function lt(t, e) {
  return `data:${e};base64,${t}`;
}
async function ht(t, e, n) {
  const o = await fetch(t, e);
  if (o.status === 404)
    throw new Error(`Resource "${o.url}" not found`);
  const i = await o.blob();
  return new Promise((s, r) => {
    const a = new FileReader();
    a.onerror = r, a.onloadend = () => {
      try {
        s(n({ res: o, result: a.result }));
      } catch (c) {
        r(c);
      }
    }, a.readAsDataURL(i);
  });
}
const Z = {};
function Mt(t, e, n) {
  let o = t.replace(/\?.*/, "");
  return n && (o = t), /ttf|otf|eot|woff2?/i.test(o) && (o = o.replace(/.*\//, "")), e ? `[${e}]${o}` : o;
}
async function N(t, e, n) {
  const o = Mt(t, e, n.includeQueryParams);
  if (Z[o] != null)
    return Z[o];
  n.cacheBust && (t += (/\?/.test(t) ? "&" : "?") + (/* @__PURE__ */ new Date()).getTime());
  let i;
  try {
    const s = await ht(t, n.fetchRequestInit, ({ res: r, result: a }) => (e || (e = r.headers.get("Content-Type") || ""), Dt(a)));
    i = lt(s, e);
  } catch (s) {
    i = n.imagePlaceholder || "";
    let r = `Failed to fetch resource: ${t}`;
    s && (r = typeof s == "string" ? s : s.message), r && console.warn(r);
  }
  return Z[o] = i, i;
}
async function Ot(t) {
  const e = t.toDataURL();
  return e === "data:," ? t.cloneNode(!1) : B(e);
}
async function Xt(t, e) {
  if (t.currentSrc) {
    const s = document.createElement("canvas"), r = s.getContext("2d");
    s.width = t.clientWidth, s.height = t.clientHeight, r == null || r.drawImage(t, 0, 0, s.width, s.height);
    const a = s.toDataURL();
    return B(a);
  }
  const n = t.poster, o = K(n), i = await N(n, o, e);
  return B(i);
}
async function At(t) {
  var e;
  try {
    if (!((e = t == null ? void 0 : t.contentDocument) === null || e === void 0) && e.body)
      return await U(t.contentDocument.body, {}, !0);
  } catch {
  }
  return t.cloneNode(!1);
}
async function Ft(t, e) {
  return P(t, HTMLCanvasElement) ? Ot(t) : P(t, HTMLVideoElement) ? Xt(t, e) : P(t, HTMLIFrameElement) ? At(t) : t.cloneNode(!1);
}
const Yt = (t) => t.tagName != null && t.tagName.toUpperCase() === "SLOT";
async function Bt(t, e, n) {
  var o, i;
  let s = [];
  return Yt(t) && t.assignedNodes ? s = T(t.assignedNodes()) : P(t, HTMLIFrameElement) && (!((o = t.contentDocument) === null || o === void 0) && o.body) ? s = T(t.contentDocument.body.childNodes) : s = T(((i = t.shadowRoot) !== null && i !== void 0 ? i : t).childNodes), s.length === 0 || P(t, HTMLVideoElement) || await s.reduce((r, a) => r.then(() => U(a, n)).then((c) => {
    c && e.appendChild(c);
  }), Promise.resolve()), e;
}
function Ht(t, e) {
  const n = e.style;
  if (!n)
    return;
  const o = window.getComputedStyle(t);
  o.cssText ? (n.cssText = o.cssText, n.transformOrigin = o.transformOrigin) : T(o).forEach((i) => {
    let s = o.getPropertyValue(i);
    i === "font-size" && s.endsWith("px") && (s = `${Math.floor(parseFloat(s.substring(0, s.length - 2))) - 0.1}px`), P(t, HTMLIFrameElement) && i === "display" && s === "inline" && (s = "block"), i === "d" && e.getAttribute("d") && (s = `path(${e.getAttribute("d")})`), n.setProperty(i, s, o.getPropertyPriority(i));
  });
}
function Ut(t, e) {
  P(t, HTMLTextAreaElement) && (e.innerHTML = t.value), P(t, HTMLInputElement) && e.setAttribute("value", t.value);
}
function Wt(t, e) {
  if (P(t, HTMLSelectElement)) {
    const n = e, o = Array.from(n.children).find((i) => t.value === i.getAttribute("value"));
    o && o.setAttribute("selected", "");
  }
}
function zt(t, e) {
  return P(e, Element) && (Ht(t, e), It(t, e), Ut(t, e), Wt(t, e)), e;
}
async function qt(t, e) {
  const n = t.querySelectorAll ? t.querySelectorAll("use") : [];
  if (n.length === 0)
    return t;
  const o = {};
  for (let s = 0; s < n.length; s++) {
    const a = n[s].getAttribute("xlink:href");
    if (a) {
      const c = t.querySelector(a), l = document.querySelector(a);
      !c && l && !o[a] && (o[a] = await U(l, e, !0));
    }
  }
  const i = Object.values(o);
  if (i.length) {
    const s = "http://www.w3.org/1999/xhtml", r = document.createElementNS(s, "svg");
    r.setAttribute("xmlns", s), r.style.position = "absolute", r.style.width = "0", r.style.height = "0", r.style.overflow = "hidden", r.style.display = "none";
    const a = document.createElementNS(s, "defs");
    r.appendChild(a);
    for (let c = 0; c < i.length; c++)
      a.appendChild(i[c]);
    t.appendChild(r);
  }
  return t;
}
async function U(t, e, n) {
  return !n && e.filter && !e.filter(t) ? null : Promise.resolve(t).then((o) => Ft(o, e)).then((o) => Bt(t, o, e)).then((o) => zt(t, o)).then((o) => qt(o, e));
}
const dt = /url\((['"]?)([^'"]+?)\1\)/g, jt = /url\([^)]+\)\s*format\((["']?)([^"']+)\1\)/g, Zt = /src:\s*(?:url\([^)]+\)\s*format\([^)]+\)[,;]\s*)+/g;
function Jt(t) {
  const e = t.replace(/([.*+?^${}()|\[\]\/\\])/g, "\\$1");
  return new RegExp(`(url\\(['"]?)(${e})(['"]?\\))`, "g");
}
function Kt(t) {
  const e = [];
  return t.replace(dt, (n, o, i) => (e.push(i), n)), e.filter((n) => !J(n));
}
async function Nt(t, e, n, o, i) {
  try {
    const s = n ? St(e, n) : e, r = K(e);
    let a;
    if (i) {
      const c = await i(s);
      a = lt(c, r);
    } else
      a = await N(s, r, o);
    return t.replace(Jt(e), `$1${a}$3`);
  } catch {
  }
  return t;
}
function Vt(t, { preferredFontFormat: e }) {
  return e ? t.replace(Zt, (n) => {
    for (; ; ) {
      const [o, , i] = jt.exec(n) || [];
      if (!i)
        return "";
      if (i === e)
        return `src: ${o};`;
    }
  }) : t;
}
function ut(t) {
  return t.search(dt) !== -1;
}
async function mt(t, e, n) {
  if (!ut(t))
    return t;
  const o = Vt(t, n);
  return Kt(o).reduce((s, r) => s.then((a) => Nt(a, r, e, n)), Promise.resolve(o));
}
async function A(t, e, n) {
  var o;
  const i = (o = e.style) === null || o === void 0 ? void 0 : o.getPropertyValue(t);
  if (i) {
    const s = await mt(i, null, n);
    return e.style.setProperty(t, s, e.style.getPropertyPriority(t)), !0;
  }
  return !1;
}
async function Gt(t, e) {
  await A("background", t, e) || await A("background-image", t, e), await A("mask", t, e) || await A("mask-image", t, e);
}
async function Qt(t, e) {
  const n = P(t, HTMLImageElement);
  if (!(n && !J(t.src)) && !(P(t, SVGImageElement) && !J(t.href.baseVal)))
    return;
  const o = n ? t.src : t.href.baseVal, i = await N(o, K(o), e);
  await new Promise((s, r) => {
    t.onload = s, t.onerror = r;
    const a = t;
    a.decode && (a.decode = s), a.loading === "lazy" && (a.loading = "eager"), n ? (t.srcset = "", t.src = i) : t.href.baseVal = i;
  });
}
async function _t(t, e) {
  const o = T(t.childNodes).map((i) => gt(i, e));
  await Promise.all(o).then(() => t);
}
async function gt(t, e) {
  P(t, Element) && (await Gt(t, e), await Qt(t, e), await _t(t, e));
}
function te(t, e) {
  const { style: n } = t;
  e.backgroundColor && (n.backgroundColor = e.backgroundColor), e.width && (n.width = `${e.width}px`), e.height && (n.height = `${e.height}px`);
  const o = e.style;
  return o != null && Object.keys(o).forEach((i) => {
    n[i] = o[i];
  }), t;
}
const nt = {};
async function ot(t) {
  let e = nt[t];
  if (e != null)
    return e;
  const o = await (await fetch(t)).text();
  return e = { url: t, cssText: o }, nt[t] = e, e;
}
async function it(t, e) {
  let n = t.cssText;
  const o = /url\(["']?([^"')]+)["']?\)/g, s = (n.match(/url\([^)]+\)/g) || []).map(async (r) => {
    let a = r.replace(o, "$1");
    return a.startsWith("https://") || (a = new URL(a, t.url).href), ht(a, e.fetchRequestInit, ({ result: c }) => (n = n.replace(r, `url(${c})`), [r, c]));
  });
  return Promise.all(s).then(() => n);
}
function st(t) {
  if (t == null)
    return [];
  const e = [], n = /(\/\*[\s\S]*?\*\/)/gi;
  let o = t.replace(n, "");
  const i = new RegExp("((@.*?keyframes [\\s\\S]*?){([\\s\\S]*?}\\s*?)})", "gi");
  for (; ; ) {
    const c = i.exec(o);
    if (c === null)
      break;
    e.push(c[0]);
  }
  o = o.replace(i, "");
  const s = /@import[\s\S]*?url\([^)]*\)[\s\S]*?;/gi, r = "((\\s*?(?:\\/\\*[\\s\\S]*?\\*\\/)?\\s*?@media[\\s\\S]*?){([\\s\\S]*?)}\\s*?})|(([\\s\\S]*?){([\\s\\S]*?)})", a = new RegExp(r, "gi");
  for (; ; ) {
    let c = s.exec(o);
    if (c === null) {
      if (c = a.exec(o), c === null)
        break;
      s.lastIndex = a.lastIndex;
    } else
      a.lastIndex = s.lastIndex;
    e.push(c[0]);
  }
  return e;
}
async function ee(t, e) {
  const n = [], o = [];
  return t.forEach((i) => {
    if ("cssRules" in i)
      try {
        T(i.cssRules || []).forEach((s, r) => {
          if (s.type === CSSRule.IMPORT_RULE) {
            let a = r + 1;
            const c = s.href, l = ot(c).then((h) => it(h, e)).then((h) => st(h).forEach((u) => {
              try {
                i.insertRule(u, u.startsWith("@import") ? a += 1 : i.cssRules.length);
              } catch (m) {
                console.error("Error inserting rule from remote css", {
                  rule: u,
                  error: m
                });
              }
            })).catch((h) => {
              console.error("Error loading remote css", h.toString());
            });
            o.push(l);
          }
        });
      } catch (s) {
        const r = t.find((a) => a.href == null) || document.styleSheets[0];
        i.href != null && o.push(ot(i.href).then((a) => it(a, e)).then((a) => st(a).forEach((c) => {
          r.insertRule(c, i.cssRules.length);
        })).catch((a) => {
          console.error("Error loading remote stylesheet", a);
        })), console.error("Error inlining remote css file", s);
      }
  }), Promise.all(o).then(() => (t.forEach((i) => {
    if ("cssRules" in i)
      try {
        T(i.cssRules || []).forEach((s) => {
          n.push(s);
        });
      } catch (s) {
        console.error(`Error while reading CSS rules from ${i.href}`, s);
      }
  }), n));
}
function ne(t) {
  return t.filter((e) => e.type === CSSRule.FONT_FACE_RULE).filter((e) => ut(e.style.getPropertyValue("src")));
}
async function oe(t, e) {
  if (t.ownerDocument == null)
    throw new Error("Provided element is not within a Document");
  const n = T(t.ownerDocument.styleSheets), o = await ee(n, e);
  return ne(o);
}
async function ie(t, e) {
  const n = await oe(t, e);
  return (await Promise.all(n.map((i) => {
    const s = i.parentStyleSheet ? i.parentStyleSheet.href : null;
    return mt(i.cssText, s, e);
  }))).join(`
`);
}
async function se(t, e) {
  const n = e.fontEmbedCSS != null ? e.fontEmbedCSS : e.skipFonts ? null : await ie(t, e);
  if (n) {
    const o = document.createElement("style"), i = document.createTextNode(n);
    o.appendChild(i), t.firstChild ? t.insertBefore(o, t.firstChild) : t.appendChild(o);
  }
}
async function re(t, e = {}) {
  const { width: n, height: o } = ct(t, e), i = await U(t, e, !0);
  return await se(i, e), await gt(i, e), te(i, e), await kt(i, n, o);
}
async function ae(t, e = {}) {
  const { width: n, height: o } = ct(t, e), i = await re(t, e), s = await B(i), r = document.createElement("canvas"), a = r.getContext("2d"), c = e.pixelRatio || wt(), l = e.canvasWidth || n, h = e.canvasHeight || o;
  return r.width = l * c, r.height = h * c, e.skipAutoScale || vt(r), r.style.width = `${l}`, r.style.height = `${h}`, e.backgroundColor && (a.fillStyle = e.backgroundColor, a.fillRect(0, 0, r.width, r.height)), a.drawImage(s, 0, 0, r.width, r.height), r;
}
async function ce(t, e = {}) {
  return (await ae(t, e)).toDataURL();
}
const H = (t, e) => t < 1 ? {
  x: e.x + 5,
  y: e.y
} : t >= 1 && t <= 3 ? {
  x: e.x,
  y: e.y + 5
} : t >= 4 && t <= 6 ? {
  x: e.x,
  y: e.y - 5
} : {
  x: e.x - 5,
  y: e.y
}, le = (t, e) => [...t].sort(
  (i, s) => {
    const r = Math.sqrt(
      (i.x - e.x) * (i.x - e.x) + (i.y - e.y) * (i.y - e.y)
    ), a = Math.sqrt(
      (s.x - e.x) * (s.x - e.x) + (s.y - e.y) * (s.y - e.y)
    );
    return r - a;
  }
).reverse(), he = (t, e, n) => {
  const {
    canvasHeight: o,
    canvasWidth: i,
    x: s,
    y: r
  } = n, { from: a, points: c, to: l } = t, h = document.querySelector(
    `#org-${e} #org-${e}-item-${a.item}-io-${a.io}`
  ), u = document.querySelector(
    `#org-${e} #org-${e}-item-${l.item}-io-${l.io}`
  );
  if (h && u) {
    const {
      height: m,
      width: d,
      x: S,
      y: p
    } = h.getBoundingClientRect().toJSON(), {
      height: $,
      width: C,
      x: I,
      y: R
    } = u.getBoundingClientRect().toJSON(), b = d / 2 + (S - s) * i, k = m / 2 + (p - r) * o, w = C / 2 + (I - s) * i, W = $ / 2 + (R - r) * o, L = {
      ...H(a.io, {
        x: Math.round(b / 5) * 5,
        y: Math.round(k / 5) * 5
      })
    }, D = {
      ...H(l.io, {
        x: Math.round(w / 5) * 5,
        y: Math.round(W / 5) * 5
      })
    };
    if (c != null && c.length) {
      const z = c.map((Fe, q) => q === c.length - 1 ? `L ${D.x} ${D.y}` : `L ${c[q + 1].x} ${c[q + 1].y}`).join(" ");
      return `M ${L.x} ${L.y} L ${c[0].x} ${c[0].y} ${z}`;
    }
    return `M ${L.x} ${L.y} L ${D.x} ${D.y}`;
  }
}, de = (t, e, n, o, i) => {
  const {
    canvasHeight: s,
    canvasWidth: r,
    x: a,
    y: c
  } = i, l = e.from.item === t, { from: h, to: u } = e, m = document.querySelector(
    `#org-${o} #org-${o}-item-${h.item}-io-${h.io}`
  ), d = document.querySelector(
    `#org-${o} #org-${o}-item-${u.item}-io-${u.io}`
  );
  if (!l && d && n && n[0]) {
    const {
      height: S,
      width: p,
      x: $,
      y: C
    } = d.getBoundingClientRect().toJSON(), I = p / 2 + ($ - a) * r, R = S / 2 + (C - c) * s, b = {
      ...H(u.io, {
        x: Math.round(I / 5) * 5,
        y: Math.round(R / 5) * 5
      })
    }, k = n[0].getAttribute("d");
    if (k) {
      const w = k.split(" ");
      return w[w.length - 2] = String(b.x), w[w.length - 1] = String(b.y), w.join(" ");
    }
  } else if (m && n && n[0]) {
    const {
      height: S,
      width: p,
      x: $,
      y: C
    } = m.getBoundingClientRect().toJSON(), I = p / 2 + ($ - a) * r, R = S / 2 + (C - c) * s, b = {
      ...H(h.io, {
        x: Math.round(I / 5) * 5,
        y: Math.round(R / 5) * 5
      })
    }, k = n[0].getAttribute("d");
    if (k) {
      const w = k.split(" ");
      return w[1] = String(b.x), w[2] = String(b.y), w.join(" ");
    }
  }
}, ue = (t, e) => {
  if (e) {
    const n = e[0].getAttribute("d");
    if (n) {
      const o = n.split(" "), i = `L ${o[o.length - 2]} ${o[o.length - 1]}`, s = `M ${o[1]} ${o[2]}`;
      if (t != null && t.length) {
        const r = t.map((c) => `L ${c.x} ${c.y}`).join(" ");
        return `${s} ${r} ${i}`;
      }
      return `${s} ${i}`;
    }
  }
}, me = rt({
  emits: {
    changePoint: (t, e) => !0,
    dragItem: (t) => !0,
    dragConnection: (t, e) => !0,
    dragPoint: (t, e) => !0,
    selectConnection: (t) => !0
  },
  props: {
    canvasState: {
      required: !0,
      type: Object
    },
    connectorState: {
      required: !0,
      type: Object
    },
    isDragged: {
      required: !1,
      type: Boolean
    },
    isEditable: {
      required: !1,
      type: Boolean
    },
    item: {
      required: !0,
      type: Object
    },
    selectedConnection: {
      required: !1,
      type: Object
    }
  },
  name: "sb-organization-tree-item",
  data() {
    return {
      connectionsPath: {}
    };
  },
  computed: {
    getItemPosition() {
      return {
        left: this.item.coordinates.x ? `${this.item.coordinates.x}px` : 0,
        top: this.item.coordinates.y ? `${this.item.coordinates.y}px` : 0
      };
    },
    isConnecting() {
      return this.connectorState.from ? this.connectorState.from.split("-io-")[0] === this.$.vnode.key : !1;
    }
  },
  methods: {
    getConnectionPath(t) {
      if (this.canvasState.elem) {
        const e = String(this.$.vnode.key).split("-item-")[0].replace("org-", ""), n = this.canvasState.elem.getBoundingClientRect().toJSON(), o = n.height || 0, i = n.width || 0, s = i / (i * this.canvasState.zoom) || 0, r = o / (o * this.canvasState.zoom) || 0;
        return he(t, e, {
          canvasHeight: r,
          canvasWidth: s,
          x: n.x,
          y: n.y
        });
      }
    },
    getConnectionPathString(t) {
      return this.connectionsPath[`${String(this.$.vnode.key)}-connection-${t.from.item}-${t.from.io}-${t.to.item}-${t.to.io}`];
    },
    getCoordinatesMove(t) {
      return t.type === "touchstart" ? {
        x: t.touches[0].clientX,
        y: t.touches[0].clientY
      } : {
        x: t.clientX,
        y: t.clientY
      };
    },
    handleCircleDoubleClick(t, e) {
      var n;
      if (this.isEditable) {
        const o = [
          ...this.item.connections || []
        ], i = [
          ...((n = o[t]) == null ? void 0 : n.points) || []
        ];
        i.splice(e, 1), o[t] = {
          ...o[t],
          points: [...i]
        };
        const s = Number(
          String(this.$.vnode.key).split("-item-")[1]
        );
        this.$emit(
          "changePoint",
          {
            ...this.item,
            connections: [...o]
          },
          s
        );
      }
    },
    handleClickIO(t, e) {
      const n = t.target;
      if (n && this.isEditable) {
        const o = n.getBoundingClientRect();
        this.$emit(
          "dragConnection",
          `${String(this.$.vnode.key)}-io-${e}`,
          o
        );
      }
    },
    handleClickPoint(t, e, n) {
      const o = t.target;
      if (o && this.isEditable) {
        const i = o.getBoundingClientRect();
        this.$emit(
          "dragPoint",
          {
            connection: e,
            item: Number(
              String(this.$.vnode.key).split("-item-")[1]
            ),
            point: n
          },
          i
        );
      }
    },
    handleConnectionClick(t, e) {
      if (this.isEditable && t.target) {
        const n = {
          ...this.item.connections[e] || {}
        };
        this.$emit("selectConnection", {
          from: n.from,
          key: `${String(this.$.vnode.key)}-connection-${e}`,
          to: n.to,
          type: n.type
        });
      }
    },
    handleConnectionDoubleClick(t, e) {
      const n = [
        ...this.item.connections || []
      ], { elem: o, zoom: i } = this.canvasState;
      if (o && this.isEditable) {
        const { height: s, width: r, x: a, y: c } = o.getBoundingClientRect().toJSON(), l = t.clientX, h = t.clientY, u = l * (r / (r * i)) - a * (r / (r * i)), m = h * (s / (s * i)) - c * (s / (s * i)), d = String(this.$.vnode.key).split(
          "-item-"
        )[0], S = document.getElementById(
          `${d}-item-${n[e].to.item}-io-${n[e].to.io}`
        );
        if (S && this.canvasState.elem) {
          const {
            height: p,
            width: $,
            x: C,
            y: I
          } = S.getBoundingClientRect().toJSON(), {
            height: R,
            width: b,
            x: k,
            y: w
          } = this.canvasState.elem.getBoundingClientRect().toJSON(), W = $ / 2 + (C - k) * b, L = p / 2 + (I - w) * R, D = [
            ...le(
              [
                ...n[e].points || [],
                {
                  x: u,
                  y: m
                }
              ],
              {
                x: W,
                y: L
              }
            )
          ];
          n[e] = {
            ...n[e],
            points: [...D]
          };
          const z = Number(
            String(this.$.vnode.key).split("-item-")[1]
          );
          this.$emit(
            "changePoint",
            {
              ...this.item,
              connections: [...n]
            },
            z
          );
        }
      }
    },
    handleInitConnections() {
      this.item.connections && (this.connectionsPath = {}, this.item.connections.forEach((t) => {
        const e = this.getConnectionPath(t);
        this.connectionsPath[`${String(this.$.vnode.key)}-connection-${t.from.item}-${t.from.io}-${t.to.item}-${t.to.io}`] = e;
      }));
    },
    handleItemClick(t) {
      if (!t.target.classList.contains("io") && this.isEditable) {
        const n = this.getCoordinatesMove(t);
        this.$emit("dragItem", {
          coordinates: n,
          elem: this.$el.nextSibling,
          key: this.$.vnode.key
        });
      }
    },
    isConnectionSelected(t) {
      return this.selectedConnection ? `${String(this.$.vnode.key)}-connection-${t}` === this.selectedConnection.key : !1;
    }
  },
  mounted() {
    this.handleInitConnections();
  },
  watch: {
    "item.connections": {
      deep: !0,
      handler(t, e) {
        if (t && e && t.length < e.length) {
          const n = [...t].map(
            (s) => `${String(this.$.vnode.key)}-connection-${s.from.item}-${s.from.io}-${s.to.item}-${s.to.io}`
          ), i = [...e].map(
            (s) => `${String(this.$.vnode.key)}-connection-${s.from.item}-${s.from.io}-${s.to.item}-${s.to.io}`
          ).find(
            (s) => n.indexOf(s) < 0
          );
          i && (delete this.connectionsPath[i], this.$nextTick(() => this.handleInitConnections()));
        } else if (t && e && t.length > e.length || !e && (t != null && t.length)) {
          const n = t[t.length - 1], o = this.getConnectionPath(n);
          this.connectionsPath[`${String(this.$.vnode.key)}-connection-${n.from.item}-${n.from.io}-${n.to.item}-${n.to.io}`] = o;
        }
      }
    }
  }
}), ge = ["id"], fe = ["id", "onMousedown", "onTouchstart"], pe = { class: "text" }, ye = ["id"], Se = ["id", "onMousedown", "onTouchstart"], $e = { class: "data-wrapper" }, Ce = { class: "name" }, Pe = { class: "position" }, we = ["innerHTML"], ve = ["id"], be = ["d"], ke = ["d", "onClick", "onDblclick"], Ee = ["cx", "cy", "onDblclick", "onMousedown", "onTouchstart"];
function Te(t, e, n, o, i, s) {
  return g(), y(x, null, [
    t.item.department ? (g(), y("div", {
      key: 0,
      class: F(["department", {
        connecting: t.isConnecting,
        draggable: t.isEditable,
        dragged: t.isDragged
      }]),
      id: String(t.$.vnode.key),
      style: X(t.getItemPosition),
      onMousedown: e[0] || (e[0] = f((...r) => t.handleItemClick && t.handleItemClick(...r), ["stop"])),
      onTouchstart: e[1] || (e[1] = f((...r) => t.handleItemClick && t.handleItemClick(...r), ["stop"]))
    }, [
      (g(!0), y(x, null, O([...Array(8).keys()], (r) => (g(), y("span", {
        class: "io",
        id: `${String(t.$.vnode.key)}-io-${r}`,
        key: `io-${r}`,
        onMousedown: f((a) => t.handleClickIO(a, r), ["stop"]),
        onTouchstart: f((a) => t.handleClickIO(a, r), ["stop"])
      }, null, 40, fe))), 128)),
      E("div", pe, j(t.item.department), 1)
    ], 46, ge)) : (g(), y("div", {
      key: 1,
      class: F(["card", {
        connecting: t.isConnecting,
        draggable: t.isEditable,
        dragged: t.isDragged
      }]),
      id: String(t.$.vnode.key),
      style: X(t.getItemPosition),
      onMousedown: e[2] || (e[2] = f((...r) => t.handleItemClick && t.handleItemClick(...r), ["stop"])),
      onTouchstart: e[3] || (e[3] = f((...r) => t.handleItemClick && t.handleItemClick(...r), ["stop"]))
    }, [
      (g(!0), y(x, null, O([...Array(8).keys()], (r) => (g(), y("span", {
        class: "io",
        id: `${String(t.$.vnode.key)}-io-${r}`,
        key: `io-${r}`,
        onMousedown: f((a) => t.handleClickIO(a, r), ["stop"]),
        onTouchstart: f((a) => t.handleClickIO(a, r), ["stop"])
      }, null, 40, Se))), 128)),
      t.item.photo ? (g(), y("div", {
        key: 0,
        class: "item-photo",
        style: X({
          backgroundImage: `url(${t.item.photo})`
        })
      }, null, 4)) : M("", !0),
      E("div", $e, [
        E("p", Ce, j(t.item.name), 1),
        E("p", Pe, j(t.item.position), 1),
        t.item.additionalInfo ? (g(), y("div", {
          key: 0,
          innerHTML: t.item.additionalInfo
        }, null, 8, we)) : M("", !0)
      ])
    ], 46, ye)),
    (g(!0), y(x, null, O(t.item.connections || [], (r, a) => (g(), y("svg", {
      class: F(["connection", [
        r.type || "solid",
        t.isConnectionSelected(a) && "selected",
        t.isEditable && "editable"
      ]]),
      xmlns: "http://www.w3.org/2000/svg",
      id: `${String(t.$.vnode.key)}-connection-${a}`,
      key: `${String(t.$.vnode.key)}-connection-${a}`
    }, [
      E("path", {
        d: t.getConnectionPathString(r)
      }, null, 8, be),
      E("path", {
        class: "real",
        d: t.getConnectionPathString(r),
        onClick: f((c) => t.handleConnectionClick(c, a), ["stop"]),
        onDblclick: f((c) => t.handleConnectionDoubleClick(c, a), ["stop"])
      }, null, 40, ke),
      (g(!0), y(x, null, O(r.points || [], (c, l) => (g(), y("circle", {
        class: "circle",
        r: "6",
        cx: c.x,
        cy: c.y,
        key: `${String(
          t.$.vnode.key
        )}-connection-${a}-circle-${l}`,
        onDblclick: f((h) => t.handleCircleDoubleClick(a, l), ["stop"]),
        onMousedown: f((h) => t.handleClickPoint(h, a, l), ["stop"]),
        onTouchstart: f((h) => t.handleClickPoint(h, a, l), ["stop"])
      }, null, 40, Ee))), 128))
    ], 10, ve))), 128))
  ], 64);
}
const xe = /* @__PURE__ */ at(me, [["render", Te]]), Ie = rt({
  emits: {
    change: (t) => !0
  },
  props: {
    isEditable: {
      required: !1,
      type: Boolean
    },
    list: {
      required: !0,
      type: Object
    }
  },
  name: "sb-organization-tree",
  components: {
    "sb-dropdown": yt,
    "sb-org-tree-item": xe
  },
  data() {
    return {
      canvasState: {
        coordinates: {
          x: 0,
          y: 0
        },
        elem: null,
        lastZoom: 1,
        zoom: 1
      },
      canvasStyle: {},
      connectorState: {
        from: null,
        fromRect: null,
        toCoordinates: null
      },
      draggedItem: null,
      exportAreaStyle: {},
      isExporting: !1,
      lineType: [
        {
          label: "Solid",
          value: "solid"
        },
        {
          label: "Dashed",
          value: "dashed"
        },
        {
          label: "Dotted",
          value: "dotted"
        }
      ],
      localList: [],
      mouseState: {
        mouse: {
          x: 0,
          y: 0
        },
        position: {
          x: 0,
          y: 0
        },
        positionStart: {
          x: 0,
          y: 0
        }
      },
      parentPointerState: {
        events: [],
        prevDiff: -1
      },
      parentState: {
        isDrag: !1,
        position: {
          x: 0,
          y: 0
        }
      },
      pointState: {
        fromRect: null,
        target: null,
        toCoordinates: null
      },
      selectedConnection: null,
      selectedLineType: "solid"
    };
  },
  computed: {
    getMinMaxXY() {
      const e = [...[...this.localList].flatMap(
        (d) => d.connections ? [...d.connections] : []
      )].flatMap(
        (d) => d.points ? [...d.points] : []
      ), n = [...this.localList].map(
        (d) => d.coordinates
      ), o = [...n].map(
        (d) => d.x
      ), i = [...n].map(
        (d) => d.x + 220
      ), s = [...n].map(
        (d) => d.y
      ), r = [...n].map(
        (d) => d.y + 100
      ), a = [
        ...[...e].map((d) => d.x),
        ...o,
        ...i
      ], c = [
        ...[...e].map((d) => d.y),
        ...s,
        ...r
      ], l = Math.max.apply(null, a), h = Math.min.apply(null, a), u = Math.max.apply(null, c), m = Math.min.apply(null, c);
      return {
        maxX: l,
        minX: h,
        maxY: u,
        minY: m
      };
    }
  },
  methods: {
    async doExport() {
      this.selectedConnection = null, this.isExporting = !0, await new Promise(
        (a) => setTimeout(() => {
          a(!0);
        }, 200)
      );
      const { maxX: t, minX: e, maxY: n, minY: o } = this.getMinMaxXY, i = Math.abs(o) + n, s = Math.abs(e) + t, r = this.canvasState.elem;
      if (this.exportAreaStyle = {
        height: `${i + 40}px`,
        width: `${s + 40}px`
      }, r) {
        const a = r.cloneNode(
          !0
        );
        a.classList.remove("connection-selected"), a.style.transform = "none", a.style.background = "transparent", a.style.height = `${i}px`, a.style.position = "relative", a.style.width = `${s}px`;
        const c = document.getElementById(
          `org-${this.$.uid}-export-area`
        );
        if (c) {
          c.appendChild(a);
          const l = await ce(
            c,
            {
              style: {
                opacity: "1"
              }
            }
          ).catch(() => null);
          return a.remove(), this.isExporting = !1, l;
        }
      }
      return null;
    },
    doParentZoom(t) {
      this.canvasState.zoom += t, this.$nextTick(() => this.doParentZoomRefresh());
    },
    doParentZoomRefresh() {
      const { coordinates: t, lastZoom: e, zoom: n } = this.canvasState, o = t.x / e * n, i = t.y / e * n;
      this.canvasState.lastZoom = n, this.canvasStyle = {
        transform: `translate(${o}px, ${i}px) scale(${n})`
      };
    },
    doSetTempConnectionPath() {
      if (this.connectorState.toCoordinates && this.connectorState.fromRect) {
        const { x: t, y: e } = this.connectorState.toCoordinates, {
          height: n,
          width: o,
          x: i,
          y: s
        } = this.connectorState.fromRect, { zoom: r } = this.canvasState, a = this.getCanvasRect(), c = (a == null ? void 0 : a.height) || 0, l = (a == null ? void 0 : a.width) || 0, h = l / (l * r) || 0, u = c / (c * r) || 0, m = (a == null ? void 0 : a.x) || 0, d = (a == null ? void 0 : a.y) || 0, S = o / 2 + (i - m) * h, p = n / 2 + (s - d) * u, $ = t * (l / (l * r)) - m * (l / (l * r)), C = e * (c / (c * r)) - d * (c / (c * r));
        this.connectorState.pathObject = {
          from: {
            x: S,
            y: p
          },
          to: {
            x: $,
            y: C
          }
        }, this.connectorState.path = `M ${S} ${p} L ${$} ${C}`;
      } else
        this.connectorState.pathObject = void 0, this.connectorState.path = void 0;
    },
    doUpdateItemMovedConnections(t) {
      this.localList.forEach(
        (e, n) => {
          [...e.connections || []].some(
            (o) => o.from.item === t || o.to.item === t
          ) && [...e.connections || []].forEach(
            (o, i) => {
              if (o.from.item === t || o.to.item === t) {
                const s = document.getElementById(
                  `org-${this.$.uid}-item-${n}-connection-${i}`
                ), r = s == null ? void 0 : s.getElementsByTagName(
                  "path"
                ), a = String(
                  this.$.uid
                ), c = this.getCanvasRect(), l = c.height || 0, h = c.width || 0, u = h / (h * this.canvasState.zoom) || 0, m = l / (l * this.canvasState.zoom) || 0, d = de(
                  t,
                  o,
                  r,
                  a,
                  {
                    canvasHeight: m,
                    canvasWidth: u,
                    x: c.x,
                    y: c.y
                  }
                );
                d && r && r[0].setAttributeNS(
                  null,
                  "d",
                  d
                );
              }
            }
          );
        }
      );
    },
    doUpdatePointMovedConnection(t, e, n) {
      const o = document.getElementById(
        `org-${this.$.uid}-item-${n}-connection-${e}`
      ), i = o == null ? void 0 : o.getElementsByTagName("path"), s = ue(
        t,
        i
      );
      s && i && i[0].setAttributeNS(null, "d", s);
    },
    getCanvasRect() {
      return this.$refs["canvas-tree"] ? {
        ...this.$refs["canvas-tree"].getBoundingClientRect().toJSON()
      } : null;
    },
    getCoordinatesEnd(t) {
      return t.type === "touchend" ? {
        x: this.mouseState.mouse.x,
        y: this.mouseState.mouse.y
      } : {
        x: t.clientX,
        y: t.clientY
      };
    },
    getCoordinatesMove(t, e) {
      const n = e || 10, i = (() => t.type === "touchmove" || t.type === "touchstart" ? {
        x: t.touches[0].clientX,
        y: t.touches[0].clientY
      } : {
        x: t.clientX,
        y: t.clientY
      })();
      return e && e < 2 ? i : Math.abs(i.x - this.parentState.position.x) >= n || Math.abs(i.y - this.parentState.position.y) >= n ? {
        x: Math.round(i.x / n) * n,
        y: Math.round(i.y / n) * n
      } : this.parentState.position;
    },
    getOptionLine(t) {
      return `
					<div class="line-opt ${t.value}">
						<div></div>
					</div>
				`;
    },
    handleChangeItemPoint(t, e) {
      this.localList[e] = { ...t }, this.$nextTick(() => this.$emit("change", this.localList));
    },
    handleChangeLineType(t) {
      if (this.selectedConnection) {
        const e = this.selectedConnection.key.split("-connection-");
        this.selectedConnection = null;
        const n = Number(
          e[0].split("-item-")[1]
        ), o = Number(e[1]);
        if (this.localList[n]) {
          const i = [
            ...this.localList[n].connections || []
          ];
          i[o].type = t, this.localList[n].connections = [...i], this.$nextTick(() => {
            this.$emit("change", this.localList);
          });
        }
      }
    },
    handleConnectionDragged(t, e) {
      this.connectorState.from = t, this.connectorState.fromRect = { ...e.toJSON() }, this.selectedConnection = null;
    },
    handleItemChangePosition(t) {
      if (this.draggedItem) {
        const e = Number(
          this.draggedItem.key.split("-item-")[1]
        ), n = [
          ...this.localList
        ], o = {
          ...n[e].coordinates
        };
        (o.x !== t.x || o.y !== t.y) && (n[e] = {
          ...this.localList[e],
          coordinates: t
        }, this.localList = [...n], this.$nextTick(
          () => this.doUpdateItemMovedConnections(e)
        ));
      }
    },
    handleItemDragged(t) {
      this.draggedItem = { ...t }, this.mouseState.position = { ...t.coordinates }, this.parentState.position = { ...t.coordinates }, this.selectedConnection = null;
    },
    handleParentClick(t) {
      const e = this.getCoordinatesMove(t, 1), n = this.$refs["connection-options-wrapper"], o = t.target;
      (!this.selectedConnection || this.selectedConnection && (!n || n && !n.contains(o) && !n.isSameNode(o))) && (this.selectedConnection = null, this.parentState.isDrag = !0, this.mouseState.mouse = { ...e }, this.mouseState.position = { ...e }, this.mouseState.positionStart = { ...e }, this.selectedLineType = "solid");
    },
    handleParentDragEnd(t) {
      const { x: e, y: n } = this.getCoordinatesEnd(t), { coordinates: o } = this.canvasState, i = o.x + -(this.mouseState.position.x - e), s = o.y + -(this.mouseState.position.y - n);
      if (this.parentState.isDrag)
        this.canvasState.coordinates = {
          x: i,
          y: s
        };
      else if (this.connectorState.from) {
        const r = t.target;
        if (r.id !== this.connectorState.from && r.classList.contains("io") && !this.isConnectionExist(
          this.connectorState.from,
          r.id
        )) {
          const c = this.connectorState.from.split("-io-")[0], l = Number(
            this.connectorState.from.split("-io-")[1]
          ), h = Number(
            c.split("-item-")[1]
          ), u = r.id.split("-io-")[0], m = Number(
            r.id.split("-io-")[1]
          ), d = Number(
            u.split("-item-")[1]
          );
          if (this.localList[h] && this.localList[d] && this.connectorState.fromRect) {
            const S = [
              ...this.localList
            ];
            S[h].connections = [
              ...S[h].connections || [],
              {
                from: {
                  io: l,
                  item: h
                },
                to: {
                  io: m,
                  item: d
                },
                type: "solid"
              }
            ], this.localList = [...S];
          }
        }
      }
      this.$nextTick(() => {
        (this.draggedItem || this.pointState.target || this.connectorState.from) && this.$nextTick(
          () => this.$emit("change", this.localList)
        ), this.parentState.isDrag = !1, this.draggedItem = null, this.connectorState = {
          from: null,
          fromRect: null,
          path: void 0,
          toCoordinates: null
        }, this.pointState = {
          fromRect: null,
          target: null,
          toCoordinates: null
        };
      });
    },
    async handleParentKeydown(t) {
      if ((t.key === "Delete" || t.key === "Backspace") && this.selectedConnection) {
        t.preventDefault();
        const e = this.selectedConnection.key.split("-connection-");
        this.selectedConnection = null;
        const n = Number(
          e[0].split("-item-")[1]
        ), o = Number(e[1]);
        if (this.localList[n]) {
          const i = [
            ...this.localList[n].connections || []
          ];
          this.localList[n].connections = i.filter(
            (s, r) => r !== o
          ), this.$nextTick(() => {
            this.$emit("change", this.localList);
          });
        }
      }
    },
    handleParentPointerDown(t) {
      this.parentPointerState.events.push(t);
    },
    handleParentPointerMove(t) {
      this.parentPointerState.events = [
        ...this.parentPointerState.events
      ].map((e) => e.pointerId === t.pointerId ? t : e), this.$nextTick(() => {
        if (this.parentPointerState.events.length === 2) {
          const e = Math.abs(
            this.parentPointerState.events[0].clientX - this.parentPointerState.events[1].clientX
          );
          this.parentPointerState.prevDiff > 100 && e > this.parentPointerState.prevDiff ? this.doParentZoom(0.1) : this.parentPointerState.prevDiff > 100 && e < this.parentPointerState.prevDiff && this.doParentZoom(-0.1), this.parentPointerState.prevDiff = e;
        }
      });
    },
    handleParentPointerUp(t) {
      this.parentPointerState.events = [
        ...this.parentPointerState.events
      ].filter((e) => e.pointerId !== t.pointerId), this.$nextTick(() => {
        this.parentPointerState.events.length < 2 && (this.parentPointerState.prevDiff = -1);
      });
    },
    handleParentPosition(t) {
      const e = this.pointState.target ? 5 : this.connectorState.from ? 1 : 10, { x: n, y: o } = this.getCoordinatesMove(
        t,
        e
      ), { x: i, y: s } = this.parentState.position, { coordinates: r, zoom: a } = this.canvasState, c = this.getCanvasRect();
      if (this.parentState.isDrag) {
        const l = r.x + -(this.mouseState.position.x - n), h = r.y + -(this.mouseState.position.y - o);
        this.canvasStyle = {
          transform: `translate(${l}px, ${h}px) scale(${a})`
        };
      } else if (this.draggedItem) {
        t.preventDefault();
        const { x: l, y: h } = this.mouseState.position, u = (l - n) * ((c == null ? void 0 : c.width) || 0) / (((c == null ? void 0 : c.width) || 0) * a), m = (h - o) * ((c == null ? void 0 : c.height) || 0) / (((c == null ? void 0 : c.height) || 0) * a);
        this.handleItemChangePosition({
          x: Math.round(
            (this.draggedItem.elem.offsetLeft - u) / 10
          ) * 10,
          y: Math.round(
            (this.draggedItem.elem.offsetTop - m) / 10
          ) * 10
        }), this.$nextTick(() => this.mouseState.position = { x: n, y: o });
      } else if (this.connectorState.from)
        this.connectorState.toCoordinates = {
          x: n,
          y: o
        }, this.$nextTick(() => this.doSetTempConnectionPath());
      else if (this.pointState.target && this.canvasState.elem && (n !== i || o !== s)) {
        const {
          height: l,
          width: h,
          x: u,
          y: m
        } = this.canvasState.elem.getBoundingClientRect().toJSON(), d = n * (h / (h * a)) - u * (h / (h * a)), S = o * (l / (l * a)) - m * (l / (l * a)), { target: p } = this.pointState, $ = [
          ...this.localList[p.item].connections || []
        ], C = [
          ...$[p.connection].points || []
        ];
        C[p.point] = {
          x: Math.round(d / 5) * 5,
          y: Math.round(S / 5) * 5
        }, this.doUpdatePointMovedConnection(
          [...C],
          p.connection,
          p.item
        ), $[p.connection] = {
          ...$[p.connection],
          points: [...C]
        }, this.localList[p.item].connections = [
          ...$
        ];
      }
      this.parentState.position = {
        x: n,
        y: o
      }, t.type === "touchmove" && (this.mouseState.mouse = {
        x: n,
        y: o
      });
    },
    handleParentZoom(t) {
      t.ctrlKey && (t.preventDefault(), t.deltaY > 0 && this.canvasState.zoom > 0.5 ? this.doParentZoom(-0.1) : this.canvasState.zoom < 1.6 && this.doParentZoom(0.1));
    },
    handlePointDragged(t, e) {
      this.pointState.target = { ...t }, this.pointState.fromRect = { ...e.toJSON() };
    },
    handleSelectConnection(t) {
      this.selectedConnection = { ...t }, this.selectedLineType = t.type || "solid";
    },
    isConnectionExist(t, e) {
      return [...this.localList].flatMap(
        (o) => o.connections ? [...o.connections] : []
      ).some((o) => {
        const i = `org-${this.$.uid}-item-${o.from.item}-io-${o.from.io}`, s = `org-${this.$.uid}-item-${o.to.item}-io-${o.to.io}`;
        return t === i && e === s || t === s && e === i;
      });
    },
    isItemDragged(t) {
      var e;
      return ((e = this.draggedItem) == null ? void 0 : e.key) === t;
    }
  },
  watch: {
    list: {
      deep: !0,
      handler(t) {
        this.localList = [...t];
      },
      immediate: !0
    }
  },
  mounted() {
    this.$refs["canvas-tree"] && (this.canvasState.elem = this.$refs["canvas-tree"]), document.addEventListener("keydown", this.handleParentKeydown);
  },
  unmounted() {
    this.canvasState.elem = null, document.removeEventListener("keydown", this.handleParentKeydown);
  },
  expose: ["doExport"]
});
const Re = ["id"], Le = {
  key: 0,
  class: "connection connecting",
  xmlns: "http://www.w3.org/2000/svg"
}, De = ["d"], Me = {
  key: 0,
  class: "connection-options-wrapper",
  ref: "connection-options-wrapper"
}, Oe = ["id"];
function Xe(t, e, n, o, i, s) {
  const r = V("sb-org-tree-item"), a = V("sb-dropdown");
  return g(), y(x, null, [
    E("div", G({
      class: [{
        connecting: t.connectorState.from,
        dragging: t.parentState.isDrag
      }, "organization-wrapper"],
      id: `org-${t.$.uid}`
    }, { ...t.$attrs }, {
      onMousedown: e[1] || (e[1] = f((...c) => t.handleParentClick && t.handleParentClick(...c), ["stop"])),
      onMousemove: e[2] || (e[2] = f((...c) => t.handleParentPosition && t.handleParentPosition(...c), ["stop"])),
      onMouseup: e[3] || (e[3] = f((...c) => t.handleParentDragEnd && t.handleParentDragEnd(...c), ["stop"])),
      onPointercancel: e[4] || (e[4] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onPointerdown: e[5] || (e[5] = (...c) => t.handleParentPointerDown && t.handleParentPointerDown(...c)),
      onPointerleave: e[6] || (e[6] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onPointermove: e[7] || (e[7] = (...c) => t.handleParentPointerMove && t.handleParentPointerMove(...c)),
      onPointerout: e[8] || (e[8] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onPointerup: e[9] || (e[9] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onTouchend: e[10] || (e[10] = f((...c) => t.handleParentDragEnd && t.handleParentDragEnd(...c), ["stop"])),
      onTouchmove: e[11] || (e[11] = f((...c) => t.handleParentPosition && t.handleParentPosition(...c), ["stop"])),
      onTouchstart: e[12] || (e[12] = f((...c) => t.handleParentClick && t.handleParentClick(...c), ["stop"])),
      onWheel: e[13] || (e[13] = f((...c) => t.handleParentZoom && t.handleParentZoom(...c), ["stop"]))
    }), [
      E("div", {
        class: F(["canvas", {
          "connection-selected": t.selectedConnection
        }]),
        ref: "canvas-tree",
        style: X(t.canvasStyle)
      }, [
        t.canvasState.elem ? (g(), y(x, { key: 0 }, [
          (g(!0), y(x, null, O(t.localList, (c, l) => (g(), Q(r, G({
            "canvas-state": t.canvasState,
            "connector-state": t.connectorState,
            "is-dragged": t.isItemDragged(`org-${t.$.uid}-item-${l}`),
            key: `org-${t.$.uid}-item-${l}`,
            "selected-connection": t.selectedConnection
          }, {
            isEditable: t.isEditable,
            item: c
          }, {
            onChangePoint: t.handleChangeItemPoint,
            onDragConnection: t.handleConnectionDragged,
            onDragItem: t.handleItemDragged,
            onDragPoint: t.handlePointDragged,
            onSelectConnection: t.handleSelectConnection
          }), null, 16, ["canvas-state", "connector-state", "is-dragged", "selected-connection", "onChangePoint", "onDragConnection", "onDragItem", "onDragPoint", "onSelectConnection"]))), 128)),
          t.connectorState.from ? (g(), y("svg", Le, [
            E("path", {
              d: t.connectorState.path
            }, null, 8, De)
          ])) : M("", !0)
        ], 64)) : M("", !0)
      ], 6),
      t.selectedConnection ? (g(), y("div", Me, [
        ft(a, {
          flat: "",
          "opt-value": "value",
          type: "flat",
          modelValue: t.selectedLineType,
          "onUpdate:modelValue": e[0] || (e[0] = (c) => t.selectedLineType = c),
          list: t.lineType,
          "opt-label": t.getOptionLine,
          onChange: t.handleChangeLineType
        }, null, 8, ["modelValue", "list", "opt-label", "onChange"])
      ], 512)) : M("", !0)
    ], 16, Re),
    (g(), Q(pt, { to: "body" }, [
      t.isExporting ? (g(), y("div", {
        key: 0,
        class: "export-area-org-chart",
        id: `org-${t.$.uid}-export-area`,
        style: X(t.exportAreaStyle)
      }, null, 12, Oe)) : M("", !0)
    ]))
  ], 64);
}
const je = /* @__PURE__ */ at(Ie, [["render", Xe]]);
export {
  je as default
};
